//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.agent;

import fipaos.agent.conversation.*;
import fipaos.agent.profile.*;
import fipaos.agent.task.*;
import fipaos.mts.*;
import fipaos.ont.fipa.fipaman.AgentID;

import fipaos.agent.conversation.standard.ConversationManagerImpl;
import fipaos.util.URL;

/**
 * Default implementation of FIPAOSAgentComponentFactory
 */
public class StandardFIPAOSAgentComponentFactory implements FIPAOSAgentComponentFactory
{
	/** Generates a ConversationManager implementation */
	public ConversationManager getCM( ConversationListener cl, MTS mts, FIPAOSAgent agent,
																		DatabaseProfile dbp, ProtocolProfile pp )
	{
		return new ConversationManagerImpl( cl, mts, agent, dbp, pp );
	}
	
		/** Generates a MTS implementation */
	public MTS getMTS( PlatformProfile p, AgentProfile ap, AgentID aid )
	{
		return new MTS( new URL( p.getAMSAddress() ), ap.getInternalAddresss(), aid );
	}
	
		/** Generates a TaskManager implementation */
	public TaskManager getTM( FIPAOSAgent agent, MessageSender ms, Task top_level_task, TaskManagerProfile tmp )
	{
		return new TaskManager( agent, ms, top_level_task, tmp );
	}
}
