//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.agent.conversation.standard.protocol;

//----------------------------------------------------------------------

import fipaos.ont.fipa.FIPACONSTANTS;
import fipaos.agent.conversation.*;
import fipaos.agent.conversation.standard.*;

//----------------------------------------------------------------------

/**
 * Specialisation of the Conversation class to deal with the fipa-propose protocol
 * <p> Implements XC00036E
 */
public class FIPAPropose extends ConversationImpl implements java.io.Serializable
{
	
	//----------------------------------------------------------------------
	// STATIC VARIABLES
	//----------------------------------------------------------------------
	
	/**
	 * Definition of protocol model
	 */
	private static Object[] __after_prop =
	{ FIPACONSTANTS.REJECT_PROPOSAL, new Integer( CONVERSATION_END ), new Integer( 1 ),
	FIPACONSTANTS.ACCEPT_PROPOSAL, new Integer( CONVERSATION_END ), new Integer( 1 ) };
	
	public static Object[] __protocol =
	{ FIPACONSTANTS.PROPOSE, new Integer( AGENT_ACTION_REQ ), new Integer( 0 ), __after_prop };
	
}
