//******************************************************************************
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files 
//     ("the Programs") are Copyright (c) 1999 - 2000 Nortel Networks
//     Corporation, 8200 Dixie Road, Suite 100, Brampton, Ontario, Canada 
//     L6R 5P6.  All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out 
//     in the Nortel Networks FIPA-OS Public License, a copy of which can be
//     found in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version 
//     can also be found at http://fipa-os.sourceforge.net/. By  downloading
//     the files containing the Programs you accept the terms and conditions of
//     the Public License. You do not have to accept these terms and conditions,
//     but unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s): 
//    Emorphia agree to provide Modifications to Nortel Networks' FIPA-OS 
//    Covered Code under Nortel Networks' FIPA-OS Public License. All Emorphia's 
//    Modifications remain Copyright (c) 2001 Emorphia Limited. All Rights
//    Reserved. 
//
//******************************************************************************

package fipaos.agent.conversation.standard.protocol;

//----------------------------------------------------------------------

import fipaos.ont.fipa.FIPACONSTANTS;
import fipaos.agent.conversation.*;
import fipaos.agent.conversation.standard.*;

//----------------------------------------------------------------------

  /**
   * Specialisation of the Conversation class to deal with the fipa-request
   * protocol
   * <br>
   * <br>
   */

public class FIPARequest extends ConversationImpl implements java.io.Serializable
{
	
	//----------------------------------------------------------------------
	// STATIC VARIABLES
	//----------------------------------------------------------------------
	
	/**
	 * Definition of protocol model
	 */
	private static Object[] __after_agree =
	{	FIPACONSTANTS.FAILURE, new Integer( CONVERSATION_END ), new Integer( 1 ),
	FIPACONSTANTS.INFORM, new Integer( CONVERSATION_END ), new Integer( 1 ) };
	
	private static Object[] __after_request =
	{ 	FIPACONSTANTS.NOT_UNDERSTOOD, new Integer( CONVERSATION_END ), new Integer( 1 ),
	FIPACONSTANTS.REFUSE, new Integer( CONVERSATION_END ), new Integer( 1 ),
	FIPACONSTANTS.AGREE, new Integer( AGENT_ACTION_REQ ), new Integer( 1 ), __after_agree };
	
	public static Object[] __protocol =
	{ FIPACONSTANTS.REQUEST, new Integer( AGENT_ACTION_REQ ), new Integer( 0 ), __after_request };
	
	
	//----------------------------------------------------------------------
	// TEST METHOD
	//----------------------------------------------------------------------
	
	public static void main( String[] args ) throws Throwable
	{
		String msgs[] =
		{ "request", "test@iiop://195.8.93.20:50/acc",
		"agree", "test2@iiop://195.8.93.20:50/acc",
		"inform", "test2@iiop://195.8.93.20:50/acc" };
		
		testAddMessages("fipa-request", msgs, false);
	}
}
