//******************************************************************************
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files 
//     ("the Programs") are Copyright (c) 1999 - 2000 Nortel Networks
//     Corporation, 8200 Dixie Road, Suite 100, Brampton, Ontario, Canada 
//     L6R 5P6.  All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out 
//     in the Nortel Networks FIPA-OS Public License, a copy of which can be
//     found in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version 
//     can also be found at http://fipa-os.sourceforge.net/. By  downloading
//     the files containing the Programs you accept the terms and conditions of
//     the Public License. You do not have to accept these terms and conditions,
//     but unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s): 
//    Emorphia agree to provide Modifications to Nortel Networks' FIPA-OS 
//    Covered Code under Nortel Networks' FIPA-OS Public License. All Emorphia's 
//    Modifications remain Copyright (c) 2001 Emorphia Limited. All Rights
//    Reserved. 
//
//******************************************************************************

package fipaos.agent.conversation.standard.protocol;

//----------------------------------------------------------------------

import fipaos.agent.conversation.*;
import fipaos.agent.conversation.standard.*;
import fipaos.ont.fipa.fipaman.AgentID;

//----------------------------------------------------------------------

  /**
   * Specialisation of the Conversation class to deal with conversations
   * that have protocols that need to be created at runtime
   * <br>
   * <br>
   */

public class RuntimeProtocol extends ConversationImpl implements java.io.Serializable
{
	
	/**
	 * Constructs a new runtime protocol object with the specified parameters. This
	 * class is used for dynamic protocol learning where we need to construct a new
	 * conversation using a protocol that we have just learned.
	 *
	 * @param protocol_name The name of the protocol
	 * @param agent_id The id of the agent that owns this conversation
	 * @param tree The protocol tree
	 **/
	public RuntimeProtocol( String protocol_name, AgentID agent_id, ConversationProtocol tree )
	{
		
		// The variables set here exist as instance variables in the superclass
		_protocol = protocol_name;
		_agent_id = agent_id;
		_protocol_tree = tree;
		
	}
	
	
}
