//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files ("the
//     Programs") are Copyright (c) 1999 - 2000 Nortel Networks Corporation, 
//     8200 Dixie Road, Suite 100, Brampton, Ontario, Canada L6R 5P6.  
//     All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out in
//     the Nortel Networks FIPA-OS Public License, a copy of which can be found
//     in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version can
//     also be found at http://fipa-os.sourceforge.net/. By downloading the
//     files containing the Programs you accept the terms and  conditions of the
//     Public License. You do not have to accept these terms and conditions, but
//     unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.agent.task.event;

//----------------------------------------------------------------------

//----------------------------------------------------------------------

/**
 * This class represents an unprocessed event for a particular Task
 */
public abstract class TaskEvent
{
	/**
	 * Time this event was created
	 */
	private final long _timestamp = System.currentTimeMillis();
		
	/** Returns the time that this was created
	 * @return Time in milliseconds passed 1 Jan 1970
	 */
	public long getTimestamp()
	{
		return _timestamp;
	}
	
	/** Returns the amount of time in milliseconds since this event was created
	 * @return The time since this was created
	 */
	public long getTimeSinceTimestamp()
	{
		return System.currentTimeMillis() - _timestamp;
	}

	/**
	 * Removes all references to other objects to aid garbage collection
	 */
	public void removeReferences()
	{
	}
} // End class

	
