//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.ont.proprietary.subscription;

import java.util.*;
import fipaos.ont.fipa.fipaman.*;

/** This object represents a SubscriptionAction object.It provides the basis for
 * describing the types of event that a particular Agent wishes to receive information
 * about.
 */
public class SubscriptionAction implements java.io.Serializable
{
	/**
	 * The condition associated with this subscription
	 */
	private String _condition[] = new String[0];
	
/** Sets the condition associated with this subscription which must be satisfied in order
 * to fire off an inform.
 * @param condition The Stringified condition(s)
 */
	public void setCondition (String condition[])
	{
		_condition = condition;
	}
	
/** Gets the condition associated with this subscription which must be satisfied in order
 * to fire off an inform.
 * @return The stringified condition(s)
 */
	public String[] getCondition ()
	{
		return _condition;
	}
}