//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files ("the
//     Programs") are Copyright (c) 1999 - 2000 Nortel Networks Corporation, 
//     8200 Dixie Road, Suite 100, Brampton, Ontario, Canada L6R 5P6.  
//     All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out in
//     the Nortel Networks FIPA-OS Public License, a copy of which can be found
//     in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version can
//     also be found at http://fipa-os.sourceforge.net/. By downloading the
//     files containing the Programs you accept the terms and  conditions of the
//     Public License. You do not have to accept these terms and conditions, but
//     unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

/* Generated By:JavaCC: Do not edit this line. SL0Parser.java */
package fipaos.parser.sl0;

import java.io.IOException;
import java.io.StringReader;
import fipaos.parser.acl.string.ACLParser;
import java.io.FileReader;
import java.io.BufferedReader;
import fipaos.util.DIAGNOSTICS;

        /**	 
	 * The SL0Parser is used to parse a string that has the
	 * format of an SL0ContentExpression as defined by fipa97.
	 * For parsing to occur, the string should be converted
	 * to a StringReader and then passed to the constructor
	 * of the SLParser. Alternatively the static method parse()
	 * may be used to do this for the user.
	 * <p>
	 * <p>
   */

        public class SL0Parser implements SL0ParserConstants {

    /**
     * parse method is the preferred method for parsing an
     * acl message string.
     * @param sl0_content_expression the expression to parse
     */
    public static void parse(String sl0_content_expression)
                                                  throws ParseException
        {
                StringReader stringreader = new StringReader(sl0_content_expression);
                SL0Parser sl0parser       = new SL0Parser(stringreader);
                fipaos.util.DIAGNOSTICS.println("created the sl parser with str reader");
                sl0parser.SL0ContentExpression();
        }


        /**
  	 * Test Harness method where a file of strings is parsed.
  	 * Each line is regarded as a separate SL0ContentExpression
  	 */
        public static void main(String[] args) throws Exception
                {
                        //print out usage instructions if needed
                        if(args.length == 0)
            {
              fipaos.util.DIAGNOSTICS.println("usage: java fipaos.parser.sl.SL0Parser filename");
              System.exit(0);
            }


      FileReader file_in = new FileReader(args[0]);
                        BufferedReader in = new BufferedReader(file_in);
                  String fileLine  = null;
                        //Loop through the file parsing each line.
                        // (null indicated eof)
                        while ((fileLine = in.readLine()) != null)
                        {
                                fipaos.util.DIAGNOSTICS.println("Line to parse is: " + fileLine);
                                try
                                {
                                        SL0Parser.parse(fileLine);
                                }
                                catch (Exception e)
                                {
                                        e.printStackTrace();
                                }
                        }
                }

  String skip_to_matching_paren() throws ParseException {
        StringBuffer string_skipped = new StringBuffer();
        Token tok;
        int nesting = 1;
        //loop until the matching parenthesis is found
        while(true)
        {
                // get the current token and match it
                // to the parenthesis
                tok = getToken(1);
                //Add the token image to the buffer
                string_skipped.append(tok.image);
        //	string_skipped.append(" ");
                //increment nesting counter if another
                // open paren is found
                if (tok.kind == Lparen) nesting++;

                // otherwise decrement nesting counter
                // and see if matching paren is found
                if(tok.kind == Rparen)
                {
                        nesting --;
                        if (nesting ==0)
                        {
                                //goPastTheLastRparen
                                tok=getNextToken();
                                break;
                        }
                }
                tok = getNextToken();
        }
        return string_skipped.toString();
  }

//----------------------------------------------------------------------
// BNF PRODUCTIONS - used to define the grammar (the non-terminals
// to parse for
// Note that lookahead is typically two as most non-terminals have
// an open parenthesis as the first character - need to test how
// lookahead works with non-terminals though!
//----------------------------------------------------------------------	
  final public void SL0ContentExpression() throws ParseException {
    if (jj_2_1(2)) {
      SL0Wff();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case Lparen:
        SL0ActionExpression();
        break;
      default:
        jj_la1[0] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void SL0Wff() throws ParseException {
    if (jj_2_2(2)) {
      SL0AtomicFormula();
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case Lparen:
        jj_consume_token(Lparen);
        SL0ActionOp();
        SL0ActionExpression();
        jj_consume_token(Rparen);
        break;
      default:
        jj_la1[1] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void SL0AtomicFormula() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case True:
      jj_consume_token(True);
      break;
    case False:
      jj_consume_token(False);
      break;
    case Word:
      SLPropositionSymbol();
      break;
    case Lparen:
      jj_consume_token(Lparen);
      SL0AtomicFormulaFactored();
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

/**
 * The production obtained by left-factorising SLAtomicFormula
 * for the beginning parenthesis.
 */
  final public void SL0AtomicFormulaFactored() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case Result:
      jj_consume_token(Result);
      SL0Term();
      SL0Term();
      jj_consume_token(Rparen);
      break;
    case Word:
      SLPredicateSymbol();
      label_1:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case Lparen:
        case Word:
        case VariableIdentifier:
        case StringLiteral:
        case IntegerLiteral:
        case FloatingPointLiteral:
          ;
          break;
        default:
          jj_la1[3] = jj_gen;
          break label_1;
        }
        SL0Term();
      }
      jj_consume_token(Rparen);
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void SL0ActionOp() throws ParseException {
    jj_consume_token(Done);
  }

  final public void SL0Term() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VariableIdentifier:
      SLVariable();
      break;
    case Word:
    case StringLiteral:
    case IntegerLiteral:
    case FloatingPointLiteral:
      SLConstant();
      break;
    default:
      jj_la1[5] = jj_gen;
      if (jj_2_3(2)) {
        SL0FunctionalTerm();
      } else if (jj_2_4(2)) {
        SL0ActionExpression();
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final public void SL0FunctionalTerm() throws ParseException {
    jj_consume_token(Lparen);
    SLFunctionSymbol();
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case Lparen:
      case Word:
      case VariableIdentifier:
      case StringLiteral:
      case IntegerLiteral:
      case FloatingPointLiteral:
        ;
        break;
      default:
        jj_la1[6] = jj_gen;
        break label_2;
      }
      SL0Term();
    }
    jj_consume_token(Rparen);
  }

  final public void SLConstant() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IntegerLiteral:
    case FloatingPointLiteral:
      NumericalConstant();
      break;
    case Word:
      jj_consume_token(Word);
      break;
    case StringLiteral:
      jj_consume_token(StringLiteral);
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void NumericalConstant() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IntegerLiteral:
      jj_consume_token(IntegerLiteral);
      break;
    case FloatingPointLiteral:
      jj_consume_token(FloatingPointLiteral);
      break;
    default:
      jj_la1[8] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void SLVariable() throws ParseException {
    jj_consume_token(VariableIdentifier);
  }

  final public void SL0ActionExpression() throws ParseException {
    jj_consume_token(Lparen);
    SL0ActionExpressionFactored();
  }

/**
 * The production obtained by left-factorising SLActionExpression
 */
  final public void SL0ActionExpressionFactored() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case Action:
      jj_consume_token(Action);
      SLAgent();
      SL0FunctionalTerm();
      jj_consume_token(Rparen);
      break;
    case MessageType:
      ACLCommunicativeActWithoutLParen();
      break;
    default:
      jj_la1[9] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void SLPropositionSymbol() throws ParseException {
    jj_consume_token(Word);
  }

  final public void SLPredicateSymbol() throws ParseException {
    jj_consume_token(Word);
  }

  final public void SLFunctionSymbol() throws ParseException {
    jj_consume_token(Word);
  }

  final public void SLAgent() throws ParseException {
    AgentName();
  }

  final public void AgentName() throws ParseException {
    jj_consume_token(AgentName);
  }

/**
 * ACLCommunicativeAct is parsed using the fipaos.parser.acl.string.ACLParser
 * generated externally. Note that the <Lparen>
 * has been parsed in ActionExpression()
 */
  final public void ACLCommunicativeActWithoutLParen() throws ParseException {
        StringBuffer str_buf = new StringBuffer();
        Token        msgtype;
        String       rest_of_acl;
        //assume that an <Lparen> has been parsed already
        str_buf.append("(");
    msgtype = jj_consume_token(MessageType);
                str_buf.append(msgtype);
                // add whitespace to separate keyword out.
                str_buf.append(" ");
    //Note that if there is no matching paren
            // then  the parsing fails in a currently
            // unknown fashion.
            rest_of_acl = skip_to_matching_paren();
                str_buf.append(rest_of_acl);
          // Now parse this string using the ACLParser
          try
          {
                fipaos.util.DIAGNOSTICS.println("acl string is : " + str_buf.toString());
                ACLParser.parse(str_buf.toString());
          }
          catch(fipaos.parser.acl.string.ParseException pe)
                {

                        fipaos.parser.sl0.ParseException toThrow = new ParseException(pe.toString());
                        // signal error to SLParser
                        {if (true) throw toThrow;}
                }
          token_source.SwitchTo(DEFAULT);
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_3R_20() {
    if (jj_3R_22()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_12() {
    if (jj_scan_token(Word)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_10() {
    if (jj_3R_15()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_11() {
    if (jj_scan_token(Lparen)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_16()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_22() {
    if (jj_scan_token(Word)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_9() {
    if (jj_scan_token(False)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_8() {
    if (jj_scan_token(True)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_4() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_8()) {
    jj_scanpos = xsp;
    if (jj_3R_9()) {
    jj_scanpos = xsp;
    if (jj_3R_10()) {
    jj_scanpos = xsp;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_3() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_2()) {
    jj_scanpos = xsp;
    if (jj_3R_7()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_3R_4()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_15() {
    if (jj_scan_token(Word)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_7() {
    if (jj_scan_token(Lparen)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_14()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_3R_3()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_17() {
    if (jj_scan_token(Action)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_13() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_17()) {
    jj_scanpos = xsp;
    if (jj_3R_18()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_18() {
    if (jj_3R_21()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_6() {
    if (jj_scan_token(Lparen)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_13()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_5() {
    if (jj_scan_token(Lparen)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_12()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_21() {
    if (jj_scan_token(MessageType)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_3R_6()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_3R_5()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_14() {
    if (jj_scan_token(Done)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_19() {
    if (jj_scan_token(Result)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_16() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_19()) {
    jj_scanpos = xsp;
    if (jj_3R_20()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public SL0ParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[10];
  final private int[] jj_la1_0 = {0x10000,0x10000,0x1190000,0x1f010000,0x1040000,0x1f000000,0x1f010000,0x1d000000,0x18000000,0xc00000,};
  final private int[] jj_la1_1 = {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private JJCalls[] jj_2_rtns = new JJCalls[4];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public SL0Parser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new SL0ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 10; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 10; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public SL0Parser(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new SL0ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 10; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 10; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public SL0Parser(SL0ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 10; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(SL0ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 10; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[33];
    for (int i = 0; i < 33; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 10; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 33; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 4; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

                  // end main()


  }
