//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.platform.ams;

import fipaos.platform.RegistrationException;

/** 
 * AMSRegistrationException is an umbrella exception type that covers all exceptions relating to
 * actions concerning the registration information of agents with the AMS. Subclasses of this exception can
 * occur during initial registration, modification of registration details, or agent deregistration actions.
 */
public class AMSRegistrationException extends RegistrationException
{

//----------------------------------------------------------------------
// CONSTRUCTOR
//----------------------------------------------------------------------

	/**
	 * Creates an exception with no reason
	 */
	public AMSRegistrationException()
	{
	}
	
	/**
	 * Creates an exception with the given reason
	 *
	 * @param error The reason for the exception
	 */
	public AMSRegistrationException( String error )
	{
		super( error );
	}
	
	/**
	 * Creates an exception with the given reason
	 *
	 * @param error The human readable reason for the exception
	 * @param reason The reason for the exception
	 */
	public AMSRegistrationException( String error, String reason )
	{
		super( error, reason );
	}		

}