//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.platform.ams;

//----------------------------------------------------------------------

import fipaos.agent.*;
import fipaos.agent.conversation.*;
import fipaos.agent.task.*;
import fipaos.ont.fipa.fipaman.*;
import fipaos.ont.fipa.*;
import fipaos.util.*;
import fipaos.skill.db.*;
import fipaos.platform.df.*;
import fipaos.ont.BASETOKENS;

//----------------------------------------------------------------------

/** This task handles the AMS get-description requests. A APDescription is
 * returned for the request.
 * <br>
 * <br>
 */
public class GetDescriptionTask extends AMSTask
{

//----------------------------------------------------------------------
// CONSTRUCTOR(S)
//----------------------------------------------------------------------

	/** This is the constructor for the AMS GetDescription task.
	 * @param conv Conversation
	 * @param ama Agent Management Action
	 * @param db Database
	 */
	public GetDescriptionTask( Conversation conv, AgentManagementAction ama, Database db )
	{
		super(conv,ama,db);
	}


//----------------------------------------------------------------------
// PUBLIC METHODS
//----------------------------------------------------------------------	
	
	/** This is the initial method called by the task.
	 */
	public void startTask()
	{
		clearMessageFlags();
		
		// Send agree
		sendAgree();
		
		// Send profile back :-)
		sendPlatformProfile();
		
		done();
	}
		

//----------------------------------------------------------------------
// MAIN/TESTING METHOD
//----------------------------------------------------------------------
  

} // End class

