//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.platform.df;

import fipaos.ont.fipa.fipaman.*;

/**
 * This is a general listener interface for use by objects wishing to
 * be informed of DF updates
 */
public interface DFListener
{
	/** Invoked when an Agent has succesfully registered with the DF
	 * @param dfad DFAgentDescription associated with this event
	 */
	public void registered( DFAgentDescription dfad );
	
	/** Invoked when an Agent has successfully updated its DFAgentDescription with the DF
	 * @param dfad DFAgentDescription associated with this event
	 */
	public void modified( DFAgentDescription dfad );
	
	/** Invoked when an Agent has successfully deregistered from the DF
	 * @param dfad DFAgentDescription associated with this event
	 */
	public void deregistered( DFAgentDescription dfad );
}