//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.platform.dfgui.swing;

import java.util.*;
import javax.swing.*;
import fipaos.ont.fipa.fipaman.*;

public class DFAgentDescriptionMapDialog extends javax.swing.JDialog
{
	List _agents;
	Map _dfads;
	JFrame _parent;
	boolean _edit;
	
	public DFAgentDescriptionMapDialog( JFrame parent, Map agents, boolean editable )
	{
		super ( parent, false );
		
		_dfads = agents;
		_agents = new LinkedList( _dfads.keySet() );
		
		initComponents ();
		jList2.setListData( new Vector( _agents ) );
		pack();
		
		// Resize and reposition window so it appears in the center
		// of the screen, and is not too large
		java.awt.Toolkit tk = java.awt.Toolkit.getDefaultToolkit();
		int width = getSize().width;
		int height = getSize().height;
		width = 200;
		height = 300;
		if( tk.getScreenSize().width < width )
		{
			width = tk.getScreenSize().width;
		}
		if( tk.getScreenSize().height < height )
		{
			height = tk.getScreenSize().height;
		}
		
		setSize( width, height );
		width = tk.getScreenSize().width - width;
		height = tk.getScreenSize().height - height;
		setLocation( width/2, height/2 );
		
		setVisible( true );
	}
	
		/** This method is called from within the constructor to
		 * initialize the form.
		 * WARNING: Do NOT modify this code. The content of this method is
		 * always regenerated by the FormEditor.
		 */
	private void initComponents()//GEN-BEGIN:initComponents
	{
		jScrollPane1 = new javax.swing.JScrollPane();
		jList2 = new javax.swing.JList();
		jButton1 = new javax.swing.JButton();
		jButton2 = new javax.swing.JButton();
		getContentPane().setLayout(new java.awt.GridBagLayout());
		java.awt.GridBagConstraints gridBagConstraints1;
		addWindowListener(new java.awt.event.WindowAdapter()
		{
			public void windowClosing(java.awt.event.WindowEvent evt)
			{
				closeDialog(evt);
			}
		}
		);
		
		
		jScrollPane1.setViewportView(jList2);
  		
  		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridwidth = 2;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints1.weightx = 1.0;
		gridBagConstraints1.weighty = 1.0;
		getContentPane().add(jScrollPane1, gridBagConstraints1);
		
		
		jButton1.setText("OK");
		jButton1.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				jButton1ActionPerformed(evt);
			}
		}
		);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 1;
		gridBagConstraints1.insets = new java.awt.Insets(3, 3, 3, 3);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
		gridBagConstraints1.weightx = 1.0;
		getContentPane().add(jButton1, gridBagConstraints1);
		
		
		jButton2.setText("View Entry");
		jButton2.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				jButton2ActionPerformed(evt);
			}
		}
		);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 1;
		gridBagConstraints1.gridy = 1;
		gridBagConstraints1.insets = new java.awt.Insets(3, 3, 3, 3);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
		getContentPane().add(jButton2, gridBagConstraints1);
		
	}//GEN-END:initComponents

  private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
		Object o = jList2.getSelectedValue();
		
		if( o != null )
		{
			DFAgentDescription dfad = (DFAgentDescription) _dfads.get( o );
			
			// Create GUI to display results
			new DFAgentDescriptionEditor( dfad.getAgentID().getName(), dfad, !_edit );
		}
  }//GEN-LAST:event_jButton2ActionPerformed

  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
		dispose();
  }//GEN-LAST:event_jButton1ActionPerformed
	
		/** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
			setVisible (false);
			dispose ();
    }//GEN-LAST:event_closeDialog
		
		/**
		 * @param args the command line arguments
		 */
		public static void main (String args[])
		{
		}
		
		
		// Variables declaration - do not modify//GEN-BEGIN:variables
		private javax.swing.JScrollPane jScrollPane1;
		private javax.swing.JList jList2;
		private javax.swing.JButton jButton1;
		private javax.swing.JButton jButton2;
		// End of variables declaration//GEN-END:variables
		
}
