//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.test.mts.service;

import java.util.*;

import junit.framework.*;

import fipaos.mts.service.*;
import fipaos.util.*;

/**
 * General purpose class for use when testing MTS Service components
 */
public class CollectorService implements PostParserService, PreParserService
{
	private Queue _recieved = new FIFOQueue();
	
	public void incoming(fipaos.mts.Message p1)
	{
		_recieved.addItem( p1 );
	}
	
	public void incoming(fipaos.ont.fipa.fipaman.Envelope p1,byte[] p2)
	{
		_recieved.addItem( new Object[] { p1, p2 } );
	}
	
	public void initialise(fipaos.mts.service.PostParserService p1,fipaos.mts.service.PostParserService p2)
	{
	}
	
	public void initialise(fipaos.mts.service.PreParserService p1,fipaos.mts.service.PreParserService p2)
	{
	}
	
	public void outgoing(fipaos.mts.Message p1)
	{
		_recieved.addItem( p1 );
	}
	
	public void outgoing(fipaos.ont.fipa.fipaman.Envelope p1,byte[] p2)
	{
		_recieved.addItem( new Object[] { p1, p2 } );
	}
	
	public void shutdown()
	{
	}
	
	public fipaos.mts.Message getNextMessage()
	{
		return (fipaos.mts.Message) _recieved.getItem();
	}
	
	public Object[] getNextEnvelopeAndByteArray()
	{
		return (Object[]) _recieved.getItem();
	}
}