//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.test.parser;

import junit.framework.*;

/**
 * Main JUnit test-harness - use with TestRunner to execute all FIPA-OS parser 
 * JUnit tests
 */
public class AllParsersTest
{
	/**
	 * Array of objects that implement Test to incorporate in test
	 */
	private static final Test[] TESTS = new Test[] {
		new fipaos.test.parser.acl.bitefficient.ParserTest( "FIPA00069 ACL Bit Efficient Test" ),
		new fipaos.test.parser.envelope.xml.ParserTest( "FIPA00085 Envelope XML Test" )		
	};
	
	/**
	 * Create a TestSuite containing all FIPA-OS parser JUnit tests
	 */
	public static Test suite()
	{
			TestSuite suite = new TestSuite( "Parsers Test Suite" ); 
			
			for( int i = 0; i < TESTS.length; i++ )
			{
				suite.addTest( TESTS[ i ] );
			}
			
			return suite;
	}
}
