//******************************************************************************
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files 
//     ("the Programs") are Copyright (c) 1999 - 2000 Nortel Networks
//     Corporation, 8200 Dixie Road, Suite 100, Brampton, Ontario, Canada 
//     L6R 5P6.  All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out 
//     in the Nortel Networks FIPA-OS Public License, a copy of which can be
//     found in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version 
//     can also be found at http://fipa-os.sourceforge.net/. By  downloading
//     the files containing the Programs you accept the terms and conditions of
//     the Public License. You do not have to accept these terms and conditions,
//     but unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s): 
//    Emorphia agree to provide Modifications to Nortel Networks' FIPA-OS 
//    Covered Code under Nortel Networks' FIPA-OS Public License. All Emorphia's 
//    Modifications remain Copyright (c) 2001 Emorphia Limited. All Rights
//    Reserved. 
//
//******************************************************************************

package fipaos.tool;

import fipaos.mts.*;
import fipaos.ont.fipa.fipaman.*;
import fipaos.ont.fipa.*;
import fipaos.util.*;

import java.awt.datatransfer.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;

public class VisualACLParser extends javax.swing.JFrame
{
	private final static String AP_VAR = "%AP%";
	
	private Icon _open = new ImageIcon( ClassLoader.getSystemResource( "images/iotest/open.jpg" ) );
	private Icon _save = new ImageIcon( ClassLoader.getSystemResource( "images/iotest/save.jpg" ) );
	private Icon _clearallfields = new ImageIcon( ClassLoader.getSystemResource( "images/iotest/clear.jpg" ) );
	private Icon _exit = new ImageIcon( ClassLoader.getSystemResource( "images/iotest/exit.jpg" ) );
	private ButtonGroup _acl_enc_group = new ButtonGroup();
	
	private boolean _shutdown = false;

	private IOTestAgent _parent = null;
	
	private java.util.List _messages = null;
	
	private File _current_dir = null;
	
	private String _current_acl_encoding = ACL.FIPA00070;
	
	/** Creates new form VisualACLParser2 */
	public VisualACLParser( IOTestAgent parent, File dir )
	{
		// Save reference to parent
		_parent = parent;
		
		// Save reference to directory
		_current_dir = dir;
		
		initComponents ();

		// Pack the frame
		pack();
		
		// Set the default colour of the system area to blue.
		// Assume bad, and change to green when printing success messages
		systArea.setForeground( Color.blue );

		// Resize and reposition window so it appears in the center
		// of the screen, and is not too large
		java.awt.Toolkit tk = java.awt.Toolkit.getDefaultToolkit();
		int width = getSize().width;
		int height = getSize().height;
		
		if( width < 320 )
		{
			width = 320;
		}
		
		if( height < 240 )
		{
			height = 240;
		}
		
		setSize( width, height );
		width = tk.getScreenSize().width - width;
		height = tk.getScreenSize().height - height;
		setLocation( width/2, height/2 );

		setVisible( true );
	}


	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the FormEditor.
	 */
	private void initComponents()//GEN-BEGIN:initComponents
	{
		menuBar = new javax.swing.JMenuBar();
		fileMenu = new javax.swing.JMenu();
		loadMenuItem = new javax.swing.JMenuItem();
		saveMenuItem = new javax.swing.JMenuItem();
		jSeparator3 = new javax.swing.JSeparator();
		jMenuItem6 = new javax.swing.JMenuItem();
		jMenu2 = new javax.swing.JMenu();
		jMenuItem1 = new javax.swing.JMenuItem();
		jMenuItem2 = new javax.swing.JMenuItem();
		jSeparator1 = new javax.swing.JSeparator();
		jMenuItem3 = new javax.swing.JMenuItem();
		jMenu1 = new javax.swing.JMenu();
		jMenu3 = new javax.swing.JMenu();
		jRadioButtonMenuItem1 = new javax.swing.JRadioButtonMenuItem();
		_acl_enc_group.add( jRadioButtonMenuItem1 );
		jRadioButtonMenuItem2 = new javax.swing.JRadioButtonMenuItem();
		_acl_enc_group.add( jRadioButtonMenuItem2 );
		jRadioButtonMenuItem3 = new javax.swing.JRadioButtonMenuItem();
		_acl_enc_group.add( jRadioButtonMenuItem3 );
		jRadioButtonMenuItem4 = new javax.swing.JRadioButtonMenuItem();
		_acl_enc_group.add( jRadioButtonMenuItem4 );
		jMenu4 = new javax.swing.JMenu();
		jCheckBoxMenuItem1 = new javax.swing.JCheckBoxMenuItem();
		jToolBar1 = new javax.swing.JToolBar();
		open = new JButton( _open );
		save = new JButton( _save );
		clearallfields = new JButton( _clearallfields );
		exit = new JButton( _exit );
		ButtonsPane = new javax.swing.JPanel();
		nextbutton = new javax.swing.JButton();
		sendbutton = new javax.swing.JButton();
		jTabbedPane1 = new javax.swing.JTabbedPane();
		MessagesPane = new javax.swing.JPanel();
		messagetype = new javax.swing.JLabel();
		messagefield = new javax.swing.JTextField();
		content = new javax.swing.JLabel();
		replywith = new javax.swing.JLabel();
		replyby = new javax.swing.JLabel();
		replyto = new javax.swing.JLabel();
		replyTo = new javax.swing.JLabel();
		lang = new javax.swing.JLabel();
		ontology = new javax.swing.JLabel();
		protocol = new javax.swing.JLabel();
		conversation = new javax.swing.JLabel();
		replywithfield = new javax.swing.JTextField();
		replybyfield = new javax.swing.JTextField();
		inreplyto = new javax.swing.JTextField();
		replytofield = new javax.swing.JTextField();
		language = new javax.swing.JTextField();
		ont = new javax.swing.JTextField();
		proto = new javax.swing.JTextField();
		convers = new javax.swing.JTextField();
		jScrollPane3 = new javax.swing.JScrollPane();
		contentArea = new javax.swing.JTextArea();
		sender = new javax.swing.JLabel();
		receiver = new javax.swing.JLabel();
		senderfield = new javax.swing.JTextField();
		receiverfield = new javax.swing.JTextField();
		AclSystemPane = new javax.swing.JPanel();
		jScrollPane5 = new javax.swing.JScrollPane();
		systArea = new javax.swing.JTextArea();
		system = new javax.swing.JLabel();
		jScrollPane1 = new javax.swing.JScrollPane();
		aclArea = new javax.swing.JTextArea();
		acl = new javax.swing.JLabel();
		jPanel1 = new javax.swing.JPanel();
		_status = new javax.swing.JLabel();
		
		fileMenu.setToolTipText("File");
  		fileMenu.setLabel("File");
  		fileMenu.setFont(new java.awt.Font ("Arial", 0, 11));
  		
  		loadMenuItem.setLabel("Load ACL Messages");
    		loadMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
    		loadMenuItem.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
    		loadMenuItem.setFont(new java.awt.Font ("Arial", 0, 11));
    		loadMenuItem.setText("Load ACL Message(s)");
    		loadMenuItem.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    		loadMenuItem.addActionListener(new java.awt.event.ActionListener()
    		{
    			public void actionPerformed(java.awt.event.ActionEvent evt)
    			{
    				openFromFile(evt);
    			}
    		}
    		);
    		fileMenu.add(loadMenuItem);
    		
  		saveMenuItem.setLabel("Save Current ACL Message");
    		saveMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
    		saveMenuItem.setActionCommand("Save ACL Message");
    		saveMenuItem.setFont(new java.awt.Font ("Arial", 0, 11));
    		saveMenuItem.setText("Save ACL Message");
    		saveMenuItem.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    		saveMenuItem.addActionListener(new java.awt.event.ActionListener()
    		{
    			public void actionPerformed(java.awt.event.ActionEvent evt)
    			{
    				saveToFile(evt);
    			}
    		}
    		);
    		fileMenu.add(saveMenuItem);
    		
  		fileMenu.add(jSeparator3);
    		
  		jMenuItem6.setLabel("Shutdown IOTestAgent");
    		jMenuItem6.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Q, java.awt.event.InputEvent.CTRL_MASK));
    		jMenuItem6.setFont(new java.awt.Font ("Arial", 0, 11));
    		jMenuItem6.setText("Exit");
    		jMenuItem6.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    		jMenuItem6.addActionListener(new java.awt.event.ActionListener()
    		{
    			public void actionPerformed(java.awt.event.ActionEvent evt)
    			{
    				exitGui(evt);
    			}
    		}
    		);
    		fileMenu.add(jMenuItem6);
    		menuBar.add(fileMenu);
  		
		jMenu2.setIcon(new javax.swing.ImageIcon(""));
  		jMenu2.setToolTipText("Edit");
  		jMenu2.setLabel("Edit");
  		jMenu2.setFont(new java.awt.Font ("Arial", 0, 11));
  		
  		jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.ALT_MASK));
    		jMenuItem1.setFont(new java.awt.Font ("Arial", 0, 11));
    		jMenuItem1.setText("Copy ACL");
    		jMenuItem1.addActionListener(new java.awt.event.ActionListener()
    		{
    			public void actionPerformed(java.awt.event.ActionEvent evt)
    			{
    				jMenuItem1ActionPerformed(evt);
    			}
    		}
    		);
    		jMenu2.add(jMenuItem1);
    		
  		jMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_V, java.awt.event.InputEvent.ALT_MASK));
    		jMenuItem2.setFont(new java.awt.Font ("Arial", 0, 11));
    		jMenuItem2.setText("Paste ACL");
    		jMenuItem2.addActionListener(new java.awt.event.ActionListener()
    		{
    			public void actionPerformed(java.awt.event.ActionEvent evt)
    			{
    				jMenuItem2ActionPerformed(evt);
    			}
    		}
    		);
    		jMenu2.add(jMenuItem2);
    		
  		jMenu2.add(jSeparator1);
    		
  		jMenuItem3.setLabel("Clear ACL Message Fields");
    		jMenuItem3.setActionCommand("Clear form");
    		jMenuItem3.setFont(new java.awt.Font ("Arial", 0, 11));
    		jMenuItem3.setText(" Clear all Fields");
    		jMenuItem3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    		jMenuItem3.addActionListener(new java.awt.event.ActionListener()
    		{
    			public void actionPerformed(java.awt.event.ActionEvent evt)
    			{
    				clearFields(evt);
    			}
    		}
    		);
    		jMenu2.add(jMenuItem3);
    		menuBar.add(jMenu2);
  		
		jMenu1.setFont(new java.awt.Font ("Arial", 0, 11));
  		jMenu1.setText("Envelope Settings");
  		
  		jMenu3.setFont(new java.awt.Font ("Arial", 0, 11));
    		jMenu3.setText("ACL Encoding");
    		
    		jRadioButtonMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_1, java.awt.event.InputEvent.CTRL_MASK));
      		jRadioButtonMenuItem1.setSelected(true);
      		jRadioButtonMenuItem1.setFont(new java.awt.Font ("Arial", 0, 11));
      		jRadioButtonMenuItem1.setText("String (FIPA00070)");
      		jRadioButtonMenuItem1.addActionListener(new java.awt.event.ActionListener()
      		{
      			public void actionPerformed(java.awt.event.ActionEvent evt)
      			{
      				jRadioButtonMenuItem1ActionPerformed(evt);
      			}
      		}
      		);
      		jMenu3.add(jRadioButtonMenuItem1);
      		
    		jRadioButtonMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_2, java.awt.event.InputEvent.CTRL_MASK));
      		jRadioButtonMenuItem2.setFont(new java.awt.Font ("Arial", 0, 11));
      		jRadioButtonMenuItem2.setText("Bit Efficient (FIPA00069)");
      		jRadioButtonMenuItem2.addActionListener(new java.awt.event.ActionListener()
      		{
      			public void actionPerformed(java.awt.event.ActionEvent evt)
      			{
      				jRadioButtonMenuItem2ActionPerformed(evt);
      			}
      		}
      		);
      		jMenu3.add(jRadioButtonMenuItem2);
      		
    		jRadioButtonMenuItem3.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_3, java.awt.event.InputEvent.CTRL_MASK));
      		jRadioButtonMenuItem3.setFont(new java.awt.Font ("Arial", 0, 11));
      		jRadioButtonMenuItem3.setText("XML (FIPA00071)");
      		jRadioButtonMenuItem3.setEnabled(false);
      		jRadioButtonMenuItem3.addActionListener(new java.awt.event.ActionListener()
      		{
      			public void actionPerformed(java.awt.event.ActionEvent evt)
      			{
      				jRadioButtonMenuItem3ActionPerformed(evt);
      			}
      		}
      		);
      		jMenu3.add(jRadioButtonMenuItem3);
      		
    		jRadioButtonMenuItem4.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_4, java.awt.event.InputEvent.CTRL_MASK));
      		jRadioButtonMenuItem4.setText("Java Serialization");
      		jRadioButtonMenuItem4.addActionListener(new java.awt.event.ActionListener()
      		{
      			public void actionPerformed(java.awt.event.ActionEvent evt)
      			{
      				jRadioButtonMenuItem4ActionPerformed(evt);
      			}
      		}
      		);
      		jMenu3.add(jRadioButtonMenuItem4);
      		jMenu1.add(jMenu3);
    		
  		jMenu4.setFont(new java.awt.Font ("Arial", 0, 11));
    		jMenu4.setText("Transport Behviour");
    		jMenu4.setEnabled(false);
    		
    		jCheckBoxMenuItem1.setText("Buffer Failed Messages");
      		jMenu4.add(jCheckBoxMenuItem1);
      		jMenu1.add(jMenu4);
    		menuBar.add(jMenu1);
  		getContentPane().setLayout(new java.awt.GridBagLayout());
		java.awt.GridBagConstraints gridBagConstraints1;
		setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
		setIconImage(new ImageIcon( ClassLoader.getSystemResource( "images/logo.gif" ) ).getImage());
		setTitle("IOTestAgent GUI");
		setForeground(java.awt.Color.white);
		setBackground(java.awt.Color.lightGray);
		setFont(new java.awt.Font ("Arial", 0, 11));
		addWindowListener(new java.awt.event.WindowAdapter()
		{
			public void windowClosing(java.awt.event.WindowEvent evt)
			{
				windowClosedEvent(evt);
			}
		}
		);
		
		jToolBar1.setBorder(new javax.swing.border.EtchedBorder());
		jToolBar1.setToolTipText("");
		jToolBar1.setFont(new java.awt.Font ("Arial", 0, 11));
		
		open.setToolTipText("Open");
  		open.setBorder(new javax.swing.border.EtchedBorder());
  		open.setFont(new java.awt.Font ("Arial", 0, 11));
  		open.addActionListener(new java.awt.event.ActionListener()
  		{
  			public void actionPerformed(java.awt.event.ActionEvent evt)
  			{
  				openFromFile(evt);
  			}
  		}
  		);
  		jToolBar1.add(open);
  		
  		
		save.setToolTipText("Save");
  		save.setBorder(new javax.swing.border.EtchedBorder());
  		save.setFont(new java.awt.Font ("Arial", 0, 11));
  		save.addActionListener(new java.awt.event.ActionListener()
  		{
  			public void actionPerformed(java.awt.event.ActionEvent evt)
  			{
  				saveToFile(evt);
  			}
  		}
  		);
  		jToolBar1.add(save);
  		
  		
		clearallfields.setToolTipText("Clear all Fields");
  		clearallfields.setBorder(new javax.swing.border.EtchedBorder());
  		clearallfields.setFont(new java.awt.Font ("Arial", 0, 11));
  		clearallfields.addActionListener(new java.awt.event.ActionListener()
  		{
  			public void actionPerformed(java.awt.event.ActionEvent evt)
  			{
  				clearFields(evt);
  			}
  		}
  		);
  		jToolBar1.add(clearallfields);
  		
  		
		exit.setToolTipText("Exit");
  		exit.setBorder(new javax.swing.border.EtchedBorder());
  		exit.setFont(new java.awt.Font ("Arial", 0, 11));
  		exit.addActionListener(new java.awt.event.ActionListener()
  		{
  			public void actionPerformed(java.awt.event.ActionEvent evt)
  			{
  				exitGui(evt);
  			}
  		}
  		);
  		jToolBar1.add(exit);
  		
  		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 0;
		gridBagConstraints1.gridwidth = 3;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(4, 0, 4, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
		gridBagConstraints1.weightx = 1.0;
		getContentPane().add(jToolBar1, gridBagConstraints1);
		
		
		ButtonsPane.setLayout(new java.awt.GridBagLayout());
		java.awt.GridBagConstraints gridBagConstraints2;
		ButtonsPane.setBorder(new javax.swing.border.EtchedBorder());
		
		nextbutton.setAlignmentX(0.4F);
  		nextbutton.setToolTipText("Next Message");
  		nextbutton.setBorder(new javax.swing.border.SoftBevelBorder(0));
  		nextbutton.setFont(new java.awt.Font ("Arial", 0, 11));
  		nextbutton.setText("Get Next Message");
  		nextbutton.addActionListener(new java.awt.event.ActionListener()
  		{
  			public void actionPerformed(java.awt.event.ActionEvent evt)
  			{
  				nextMessageActionEvent(evt);
  			}
  		}
  		);
  		gridBagConstraints2 = new java.awt.GridBagConstraints();
  		gridBagConstraints2.gridx = 1;
  		gridBagConstraints2.gridy = 0;
  		gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
  		gridBagConstraints2.ipadx = 35;
  		gridBagConstraints2.ipady = 4;
  		gridBagConstraints2.insets = new java.awt.Insets(1, 6, 1, 2);
  		gridBagConstraints2.anchor = java.awt.GridBagConstraints.EAST;
  		gridBagConstraints2.weightx = 1.0;
  		ButtonsPane.add(nextbutton, gridBagConstraints2);
  		
  		
		sendbutton.setToolTipText("Send to Agent");
  		sendbutton.setBorder(new javax.swing.border.SoftBevelBorder(0));
  		sendbutton.setActionCommand("send to agent");
  		sendbutton.setFont(new java.awt.Font ("Arial", 0, 11));
  		sendbutton.setText("Send Message");
  		sendbutton.addActionListener(new java.awt.event.ActionListener()
  		{
  			public void actionPerformed(java.awt.event.ActionEvent evt)
  			{
  				sendtoagentActionPerformed(evt);
  			}
  		}
  		);
  		gridBagConstraints2 = new java.awt.GridBagConstraints();
  		gridBagConstraints2.gridx = 0;
  		gridBagConstraints2.gridy = 0;
  		gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
  		gridBagConstraints2.ipadx = 31;
  		gridBagConstraints2.ipady = 4;
  		gridBagConstraints2.insets = new java.awt.Insets(2, 3, 1, 7);
  		gridBagConstraints2.anchor = java.awt.GridBagConstraints.EAST;
  		gridBagConstraints2.weightx = 1.0;
  		ButtonsPane.add(sendbutton, gridBagConstraints2);
  		
  		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 2;
		gridBagConstraints1.gridy = 3;
		gridBagConstraints1.ipady = 3;
		gridBagConstraints1.insets = new java.awt.Insets(4, 0, 4, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
		getContentPane().add(ButtonsPane, gridBagConstraints1);
		
		
		jTabbedPane1.setPreferredSize(new java.awt.Dimension(510, 450));
		jTabbedPane1.setBorder(new javax.swing.border.EtchedBorder());
		jTabbedPane1.setName("");
		jTabbedPane1.setMinimumSize(new java.awt.Dimension(11, 10));
		jTabbedPane1.setToolTipText("");
		jTabbedPane1.setFont(new java.awt.Font ("Arial", 0, 11));
		jTabbedPane1.addFocusListener(new java.awt.event.FocusAdapter()
		{
			public void focusGained(java.awt.event.FocusEvent evt)
			{
				jTabbedPane1FocusGained(evt);
			}
		}
		);
		
		MessagesPane.setLayout(new java.awt.GridBagLayout());
  		java.awt.GridBagConstraints gridBagConstraints3;
  		MessagesPane.setBorder(new javax.swing.border.EtchedBorder());
  		MessagesPane.setName("Messages");
  		MessagesPane.setMinimumSize(new java.awt.Dimension(11, 10));
  		MessagesPane.setFont(new java.awt.Font ("Arial", 0, 11));
  		
  		messagetype.setText("Performative");
    		messagetype.setForeground(java.awt.Color.black);
    		messagetype.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.gridy = 0;
    		gridBagConstraints3.ipadx = 4;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.NORTHEAST;
    		MessagesPane.add(messagetype, gridBagConstraints3);
    		
    		
  		messagefield.setAlignmentY(0.9F);
    		messagefield.setAlignmentX(0.9F);
    		messagefield.setToolTipText("");
    		messagefield.setColumns(55);
    		messagefield.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 1;
    		gridBagConstraints3.gridy = 0;
    		gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints3.ipadx = 1;
    		gridBagConstraints3.ipady = 1;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.NORTHEAST;
    		gridBagConstraints3.weightx = 1.0;
    		MessagesPane.add(messagefield, gridBagConstraints3);
    		
    		
  		content.setText("Content");
    		content.setForeground(java.awt.Color.black);
    		content.setBackground(java.awt.Color.white);
    		content.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    		content.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.gridy = 3;
    		gridBagConstraints3.ipadx = 4;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
    		MessagesPane.add(content, gridBagConstraints3);
    		
    		
  		replywith.setText("Reply-With");
    		replywith.setForeground(java.awt.Color.black);
    		replywith.setBackground(java.awt.Color.white);
    		replywith.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    		replywith.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.gridy = 4;
    		gridBagConstraints3.ipadx = 4;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
    		MessagesPane.add(replywith, gridBagConstraints3);
    		
    		
  		replyby.setText("Reply-By");
    		replyby.setForeground(java.awt.Color.black);
    		replyby.setBackground(java.awt.Color.white);
    		replyby.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    		replyby.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.gridy = 5;
    		gridBagConstraints3.ipadx = 4;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
    		MessagesPane.add(replyby, gridBagConstraints3);
    		
    		
  		replyto.setText("In-Reply-To");
    		replyto.setForeground(java.awt.Color.black);
    		replyto.setBackground(java.awt.Color.white);
    		replyto.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    		replyto.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.gridy = 6;
    		gridBagConstraints3.ipadx = 4;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
    		MessagesPane.add(replyto, gridBagConstraints3);
    		
    		
  		replyTo.setText("Reply To");
    		replyTo.setForeground(java.awt.Color.black);
    		replyTo.setBackground(java.awt.Color.white);
    		replyTo.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    		replyTo.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.gridy = 7;
    		gridBagConstraints3.ipadx = 4;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
    		MessagesPane.add(replyTo, gridBagConstraints3);
    		
    		
  		lang.setText("Language");
    		lang.setForeground(java.awt.Color.black);
    		lang.setBackground(java.awt.Color.white);
    		lang.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    		lang.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.gridy = 8;
    		gridBagConstraints3.ipadx = 4;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
    		MessagesPane.add(lang, gridBagConstraints3);
    		
    		
  		ontology.setText("Ontology");
    		ontology.setForeground(java.awt.Color.black);
    		ontology.setBackground(java.awt.Color.white);
    		ontology.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    		ontology.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.gridy = 9;
    		gridBagConstraints3.ipadx = 4;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
    		MessagesPane.add(ontology, gridBagConstraints3);
    		
    		
  		protocol.setText("Protocol");
    		protocol.setForeground(java.awt.Color.black);
    		protocol.setBackground(java.awt.Color.white);
    		protocol.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    		protocol.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.gridy = 10;
    		gridBagConstraints3.ipadx = 4;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
    		MessagesPane.add(protocol, gridBagConstraints3);
    		
    		
  		conversation.setText("Conversation ID");
    		conversation.setForeground(java.awt.Color.black);
    		conversation.setBackground(java.awt.Color.white);
    		conversation.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    		conversation.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.gridy = 11;
    		gridBagConstraints3.ipadx = 4;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
    		MessagesPane.add(conversation, gridBagConstraints3);
    		
    		
  		replywithfield.setColumns(55);
    		replywithfield.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 1;
    		gridBagConstraints3.gridy = 4;
    		gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints3.ipadx = 1;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.weightx = 1.0;
    		MessagesPane.add(replywithfield, gridBagConstraints3);
    		
    		
  		replybyfield.setColumns(55);
    		replybyfield.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 1;
    		gridBagConstraints3.gridy = 5;
    		gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints3.ipadx = 1;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.weightx = 1.0;
    		MessagesPane.add(replybyfield, gridBagConstraints3);
    		
    		
  		inreplyto.setColumns(55);
    		inreplyto.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 1;
    		gridBagConstraints3.gridy = 6;
    		gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints3.ipadx = 1;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.weightx = 1.0;
    		MessagesPane.add(inreplyto, gridBagConstraints3);
    		
    		
  		replytofield.setColumns(55);
    		replytofield.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 1;
    		gridBagConstraints3.gridy = 7;
    		gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints3.ipadx = 1;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.weightx = 1.0;
    		MessagesPane.add(replytofield, gridBagConstraints3);
    		
    		
  		language.setColumns(55);
    		language.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 1;
    		gridBagConstraints3.gridy = 8;
    		gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints3.ipadx = 1;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.weightx = 1.0;
    		MessagesPane.add(language, gridBagConstraints3);
    		
    		
  		ont.setColumns(55);
    		ont.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 1;
    		gridBagConstraints3.gridy = 9;
    		gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints3.ipadx = 1;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.weightx = 1.0;
    		MessagesPane.add(ont, gridBagConstraints3);
    		
    		
  		proto.setColumns(55);
    		proto.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 1;
    		gridBagConstraints3.gridy = 10;
    		gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints3.ipadx = 1;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.weightx = 1.0;
    		MessagesPane.add(proto, gridBagConstraints3);
    		
    		
  		convers.setColumns(55);
    		convers.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 1;
    		gridBagConstraints3.gridy = 11;
    		gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints3.ipadx = 1;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.weightx = 1.0;
    		MessagesPane.add(convers, gridBagConstraints3);
    		
    		
  		jScrollPane3.setAutoscrolls(true);
    		
    		contentArea.setLineWrap(true);
      		jScrollPane3.setViewportView(contentArea);
      		
      		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 1;
    		gridBagConstraints3.gridy = 3;
    		gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.weightx = 1.0;
    		gridBagConstraints3.weighty = 1.0;
    		MessagesPane.add(jScrollPane3, gridBagConstraints3);
    		
    		
  		sender.setText("Sender");
    		sender.setForeground(java.awt.Color.black);
    		sender.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.gridy = 1;
    		gridBagConstraints3.ipadx = 4;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
    		MessagesPane.add(sender, gridBagConstraints3);
    		
    		
  		receiver.setText("Receiver");
    		receiver.setForeground(java.awt.Color.black);
    		receiver.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.gridy = 2;
    		gridBagConstraints3.ipadx = 4;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
    		MessagesPane.add(receiver, gridBagConstraints3);
    		
    		
  		senderfield.setToolTipText("");
    		senderfield.setColumns(55);
    		senderfield.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 1;
    		gridBagConstraints3.gridy = 1;
    		gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints3.ipadx = 1;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.weightx = 1.0;
    		MessagesPane.add(senderfield, gridBagConstraints3);
    		
    		
  		receiverfield.setToolTipText("");
    		receiverfield.setColumns(55);
    		receiverfield.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints3 = new java.awt.GridBagConstraints();
    		gridBagConstraints3.gridx = 1;
    		gridBagConstraints3.gridy = 2;
    		gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints3.ipadx = 1;
    		gridBagConstraints3.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints3.weightx = 1.0;
    		MessagesPane.add(receiverfield, gridBagConstraints3);
    		
    		jTabbedPane1.addTab("Current ACL Message", null, MessagesPane, "Message Infomation");
  		
  		
		AclSystemPane.setLayout(new java.awt.GridBagLayout());
  		java.awt.GridBagConstraints gridBagConstraints4;
  		AclSystemPane.setPreferredSize(new java.awt.Dimension(240, 50));
  		AclSystemPane.setBorder(new javax.swing.border.EtchedBorder());
  		AclSystemPane.setName("ACL/System Messages");
  		AclSystemPane.setMinimumSize(new java.awt.Dimension(11, 10));
  		AclSystemPane.setToolTipText("ACL/System Message");
  		
  		jScrollPane5.setMaximumSize(new java.awt.Dimension(80, 50));
    		jScrollPane5.setHorizontalScrollBar(jScrollPane5.getHorizontalScrollBar());
    		jScrollPane5.setAutoscrolls(true);
    		
    		systArea.setLineWrap(true);
      		systArea.setEditable(false);
      		jScrollPane5.setViewportView(systArea);
      		
      		gridBagConstraints4 = new java.awt.GridBagConstraints();
    		gridBagConstraints4.gridx = 0;
    		gridBagConstraints4.gridy = 4;
    		gridBagConstraints4.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints4.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints4.weightx = 1.0;
    		gridBagConstraints4.weighty = 1.0;
    		AclSystemPane.add(jScrollPane5, gridBagConstraints4);
    		
    		
  		system.setText("IOTestAgent Status Messages");
    		system.setForeground(java.awt.Color.black);
    		system.setBackground(java.awt.Color.white);
    		system.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    		system.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints4 = new java.awt.GridBagConstraints();
    		gridBagConstraints4.gridx = 0;
    		gridBagConstraints4.gridy = 3;
    		gridBagConstraints4.ipadx = 1;
    		gridBagConstraints4.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
    		AclSystemPane.add(system, gridBagConstraints4);
    		
    		
  		jScrollPane1.setMaximumSize(new java.awt.Dimension(80, 50));
    		jScrollPane1.setHorizontalScrollBar(jScrollPane1.getHorizontalScrollBar());
    		jScrollPane1.setAutoscrolls(true);
    		
    		aclArea.setLineWrap(true);
      		aclArea.setEditable(false);
      		jScrollPane1.setViewportView(aclArea);
      		
      		gridBagConstraints4 = new java.awt.GridBagConstraints();
    		gridBagConstraints4.gridx = 0;
    		gridBagConstraints4.gridy = 2;
    		gridBagConstraints4.fill = java.awt.GridBagConstraints.BOTH;
    		gridBagConstraints4.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints4.weightx = 1.0;
    		gridBagConstraints4.weighty = 1.0;
    		AclSystemPane.add(jScrollPane1, gridBagConstraints4);
    		
    		
  		acl.setText("Loaded/Received ACL Messages");
    		acl.setForeground(java.awt.Color.black);
    		acl.setBackground(java.awt.Color.white);
    		acl.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    		acl.setFont(new java.awt.Font ("Arial", 0, 11));
    		gridBagConstraints4 = new java.awt.GridBagConstraints();
    		gridBagConstraints4.gridx = 0;
    		gridBagConstraints4.gridy = 0;
    		gridBagConstraints4.gridheight = 2;
    		gridBagConstraints4.ipadx = 1;
    		gridBagConstraints4.insets = new java.awt.Insets(6, 8, 6, 8);
    		gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
    		AclSystemPane.add(acl, gridBagConstraints4);
    		
    		jTabbedPane1.addTab("ACL/System Messages", null, AclSystemPane, "ACL/Sysem Messages");
  		
  		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 1;
		gridBagConstraints1.gridwidth = 3;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints1.weightx = 1.0;
		gridBagConstraints1.weighty = 1.0;
		getContentPane().add(jTabbedPane1, gridBagConstraints1);
		
		
		jPanel1.setLayout(new java.awt.GridBagLayout());
		java.awt.GridBagConstraints gridBagConstraints5;
		jPanel1.setBorder(new javax.swing.border.SoftBevelBorder(1));
		
		_status.setText("IOTestAgent started");
  		_status.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
  		gridBagConstraints5 = new java.awt.GridBagConstraints();
  		gridBagConstraints5.fill = java.awt.GridBagConstraints.HORIZONTAL;
  		gridBagConstraints5.anchor = java.awt.GridBagConstraints.WEST;
  		gridBagConstraints5.weightx = 1.0;
  		jPanel1.add(_status, gridBagConstraints5);
  		
  		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 2;
		gridBagConstraints1.gridwidth = 3;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
		getContentPane().add(jPanel1, gridBagConstraints1);
		
		setJMenuBar(menuBar);
		
	}//GEN-END:initComponents

  private void jRadioButtonMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem4ActionPerformed
		_current_acl_encoding = ACL.FIPA_OS_SERIALIZATION;
  }//GEN-LAST:event_jRadioButtonMenuItem4ActionPerformed

  private void jTabbedPane1FocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTabbedPane1FocusGained
		aclArea.setCaretPosition(aclArea.getDocument().getLength());
		systArea.setCaretPosition(systArea.getDocument().getLength());
  }//GEN-LAST:event_jTabbedPane1FocusGained

  private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed

		// Attempt to pull data from clip board
		Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
		
		if( clipboard != null )
		{
			Transferable t = clipboard.getContents( this );
			if( t.isDataFlavorSupported( DataFlavor.stringFlavor ) )
			{
				try
				{
					String s = (String) t.getTransferData( DataFlavor.stringFlavor );
					setACLMessage( new ACL( s ) );
				}
				catch( Throwable x )
				{
					_status.setText( "Unable to paste clipboard, problems parsing" );
				}
			}
			else
			{
				_status.setText( "Unable to paste clipboard, unsupported DataFlavour" );
			}
		}
		
  }//GEN-LAST:event_jMenuItem2ActionPerformed

  private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed

		// Attempt to pull data from clip board
		Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
		
		if( clipboard != null )
		{
			ACL acl = getACLMessage();
			
			if( acl != null )
			{
				StringSelection string = new StringSelection( acl.toString() );
				clipboard.setContents( string, string );
			}
			else
			{
				_status.setText( "Couldn't copy message to clipboard, parsing error" );
			}
		}

  }//GEN-LAST:event_jMenuItem1ActionPerformed

  private void jRadioButtonMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem3ActionPerformed
		_current_acl_encoding = ACL.FIPA00071;
  }//GEN-LAST:event_jRadioButtonMenuItem3ActionPerformed

  private void jRadioButtonMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem2ActionPerformed
		_current_acl_encoding = ACL.FIPA00069;
  }//GEN-LAST:event_jRadioButtonMenuItem2ActionPerformed

  private void jRadioButtonMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem1ActionPerformed
		_current_acl_encoding = ACL.FIPA00070;
  }//GEN-LAST:event_jRadioButtonMenuItem1ActionPerformed

  private void windowClosedEvent (java.awt.event.WindowEvent evt) {//GEN-FIRST:event_windowClosedEvent
		exit();
  }//GEN-LAST:event_windowClosedEvent

  private void nextMessageActionEvent (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextMessageActionEvent
		// See if there is another message
		if( _messages != null && _messages.size() > 1 )
		{
			// Remove head
			_messages.remove( 0 );
			
			// Display next
			setACLMessage( (ACL) _messages.get( 0 ) );
		}
		else
		{
			_messages = null;
			println( "No more messages to display!" );
		}
  }//GEN-LAST:event_nextMessageActionEvent

  private void exitGui (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitGui
		setVisible( false );
		dispose();
		_parent.shutdown();
  }//GEN-LAST:event_exitGui

  private void clearFields (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearFields
		clearFields();
  }//GEN-LAST:event_clearFields

  private void deparseMessage (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deparseMessage
  }//GEN-LAST:event_deparseMessage

  private void parseMessage (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_parseMessage
  }//GEN-LAST:event_parseMessage

  private void saveToFile (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveToFile
		// Create a save file dialog
		JFileChooser save = new JFileChooser( _current_dir );
		int result = save.showSaveDialog( this );
		
		// OK pressed?
		if( result == JFileChooser.APPROVE_OPTION )
		{
			PrintWriter pw = null;
			
			// Save selected directory
			_current_dir = new File( save.getSelectedFile().getParent() );
			
			try
			{
				// Get ACL
				ACL msg = getACLMessage();
				
				// Check we got ACL OK
				if( msg == null )
				{
					println( "Couldn't create ACL message, aborting" );
					return;
				}
				
				// Create file
				File file = save.getSelectedFile();
				pw = new PrintWriter( new FileWriter( file ) );
				pw.println( msg.toString() );
			}
			catch( Throwable t )
			{
				println( "Some exception occured whilst saving: " + t );
			}
			finally
			{
				if( pw != null )
				{
					try
					{
						pw.close();
					}
					catch( Throwable t )
					{
					}
				}
			}
		}

  }//GEN-LAST:event_saveToFile

  private void openFromFile (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openFromFile
		// Create an open file dialog
		JFileChooser open = new JFileChooser( _current_dir );
		int result = open.showOpenDialog( this );
		
		// OK pressed?
		if( result == JFileChooser.APPROVE_OPTION )
		{
			// Load file & parse it
			String doc = DocumentRetriever.getDocFromFile( open.getSelectedFile().getPath() );
			
			// Save selected directory
			_current_dir = new File( open.getSelectedFile().getParent() );
			
			// Check if we got doc
			if( doc == null )
			{
				println( "Some error occured reading from file, aborted." );
				return;
			}
			
			// Get HAP name
			String agent_name = _parent.getAID().getName();
			String hap = agent_name.substring( agent_name.indexOf( '@' ) + 1 );
			
			
			// Attempt to replace all occurences of "%AP%" with the HAP name
			int index = doc.indexOf( AP_VAR );
			int last_index = 0;
			StringBuffer buff = new StringBuffer();
			while( index > -1 )
			{
				buff.append( doc.substring( last_index, index ) );
				buff.append( hap );
				last_index = index + AP_VAR.length();
				index = doc.indexOf( AP_VAR, last_index );
			}
			buff.append( doc.substring( last_index ) );
			

			// Parse doc
			java.util.List msgs = StringParser.parseACL( buff.toString() );
			
			// Check if messages parsed OK
			if( msgs == null || msgs.size() == 0 )
			{
				println( "Some error occured parsing ACL messages, aborted" );
				return;
			}
			
			// Make these the current messages to use
			_messages = msgs;
			setACLMessage( (ACL) msgs.get( 0 ) );
		}
  }//GEN-LAST:event_openFromFile
	
  private void sendtoagentActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sendtoagentActionPerformed
		// Get the message from the GUI
		ACL acl = getACLMessage();
		
		// Check if the message was got OK
		if( acl != null )
		{
			// Create Message
			Message msg = new Message( acl );
			
			// Set ACL encoding
			msg.getEnvelope().setACLRepresentation( _current_acl_encoding );
			
			// Send the message
			_parent.send( msg );
		}
  }//GEN-LAST:event_sendtoagentActionPerformed

	/**
	 * This method is used when agent wants to get the ACLMessage from the GUI.
	 * @return fipaos.parser.acl.ACLMessage ACLMessage from the GUI
	 */
	public ACL getACLMessage()
	{
		fipaos.parser.acl.ACLMessage 	acl			= new fipaos.parser.acl.ACLMessage();

		String 				PARSED_OK 		= new String("String has been parsed, no errors");

		String 				messageType 	        = null;
		String 				sender 			= null;
		String 				receiver 		= null;
		String 				content 		= null;
		String 				reply_with 		= null;
		String 				reply_by 		= null;
		String 				in_reply_to 	        = null;
		String 				reply_to 		= null;
		String 				lang 		        = null;
		String 				ontology 		= null;
		String 				protocol 		= null;
		String 				conversation     	= null;
		String 				message 		= null;
		java.util.Vector                ACLMessageList 	        = null;

		messageType = messagefield.getText();
		sender = senderfield.getText();
		receiver = receiverfield.getText();
		content = contentArea.getText();
		reply_with = replywithfield.getText();
		reply_by = replybyfield.getText();
		in_reply_to = inreplyto.getText();
		reply_to = replytofield.getText();
		lang = language.getText();
		ontology = ont.getText();
		protocol = proto.getText();
		conversation = convers.getText();

		try
		{
			if (!messageType.equals(""))
			{
				acl.setPerformative( messageType );

				if (! sender.equals(""))
				{
					acl.setSender( sender );
				}
				if (! receiver.equals(""))
				{
					acl.setReceiver( receiver );
				}
				if (! content.equals(""))
				{
					acl.setContent( content );
				}
				if (! reply_with.equals(""))
				{
					acl.setReplyWith( reply_with );
				}
				if (! reply_by.equals(""))
				{
					acl.setReplyBy( reply_by );
				}
				if (! in_reply_to.equals(""))
				{
					acl.setInReplyTo( in_reply_to );
				}
				if (! reply_to.equals(""))
				{
					acl.setReplyTo( reply_to );
				}
				if (! lang.equals(""))
				{
					acl.setLanguage( lang );
				}
				if (! ontology.equals(""))
				{
					acl.setOntology( ontology );
				}
				if (! protocol.equals(""))
				{
					acl.setProtocol( protocol );
				}
				if (! conversation.equals(""))
				{
					acl.setConversationID( conversation );
				}

				acl = fipaos.parser.acl.string.ACLParser.parse( acl.toString() );

				println("Parsed OK");
			}
			else
			{
				println("No message type entered");
			}
			
			new ACL( acl.toString() );
		}
		catch(Throwable e)
		{
			println( "ERROR WITH DEPARSING: " + e );
			acl = null;
		}

		return acl;
	}

	
	/**
	 * Sets the IOTestAgent to display the given ACL message
	 */
	public void setACLMessage( ACL msg )
	{
		// Add ACL to message window
		aclArea.append( msg.toString() + "\n\n" );
		aclArea.setCaretPosition(aclArea.getDocument().getLength());
		
		try
		{
			if( !( msg.getPerformative() == null ) )
			{
				messagefield.setText(msg.getPerformative());
			}
			else
			{
				messagefield.setText("");				
			}

			if( !( msg.getSenderAID() == null ) )
			{
				senderfield.setText(msg.getSenderAID().toString());
			}
			else
			{
				senderfield.setText("");				
			}

			// Append all AID's together
			Iterator i = msg.getReceiverAIDs().iterator();
			String rcvr = "";
			while( i.hasNext() )
			{
				rcvr += i.next().toString() + " ";
			}
			receiverfield.setText( rcvr );
			
			contentArea.setText( msg.getContentObject().toString() );

			replywithfield.setText(msg.getReplyWith());

			if( !( msg.getReplyByUTC() == null ) )
			{
				replybyfield.setText( msg.getReplyByUTC().toString() );
			}
			else
			{
				replybyfield.setText("");				
			}

			if( !( msg.getInReplyTo() == null ) )
			{
				inreplyto.setText(msg.getInReplyTo());
			}
			else
			{
				inreplyto.setText("");				
			}

			if( !( msg.getReplyToAIDs() == null ) && msg.getReplyToAIDs().size() > 0 )
			{
				replytofield.setText(fipaos.util.StringParser.trimSquareBrackets( msg.getReplyToAIDs().toString() ) );
			}
			else
			{
				replytofield.setText("");				
			}

			if( !( msg.getLanguage() == null ) )
			{
				language.setText(msg.getLanguage());
			}
			else
			{
				language.setText("");				
			}

			if( !( msg.getOntology() == null ) )
			{
				ont.setText(msg.getOntology());
			}
			else
			{
				ont.setText("");				
			}

			if( !( msg.getProtocol() == null ) )
			{
				proto.setText(msg.getProtocol());
			}
			else
			{
				proto.setText("");				
			}

			if( !( msg.getConversationID() == null ) )
			{
				convers.setText(msg.getConversationID());
			}
			else
			{
				convers.setText("");				
			}

			println("Parsed OK");
		}
		catch( Throwable e)
		{
			println("ERROR WITH PARSING: " + e);
		}
	}


	/**
	 * Clears all the fields.
	 */
	private void clearFields()
	{
		receiverfield.setText("");
		replywithfield.setText("");
		replybyfield.setText("");
		inreplyto.setText("");
		replytofield.setText("");
		language.setText("");
		ont.setText("");
		senderfield.setText("");
		proto.setText("");
		convers.setText("");
		messagefield.setText("");
		contentArea.setText("");
	}


	/**
	 * This method sets a system message.
	 * @param message java.lang.String
	 */
	public void println(String message)
	{
		systArea.append( message + "\n" );
		systArea.setCaretPosition(systArea.getDocument().getLength());
		_status.setText( message );
	}

	
	/**
	 * Closes the GUI & shuts-down parent IOTestAgent
	 */
	private void exit()
	{
		setVisible( false );
	}
	
	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JMenuBar menuBar;
	private javax.swing.JMenu fileMenu;
	private javax.swing.JMenuItem loadMenuItem;
	private javax.swing.JMenuItem saveMenuItem;
	private javax.swing.JSeparator jSeparator3;
	private javax.swing.JMenuItem jMenuItem6;
	private javax.swing.JMenu jMenu2;
	private javax.swing.JMenuItem jMenuItem1;
	private javax.swing.JMenuItem jMenuItem2;
	private javax.swing.JSeparator jSeparator1;
	private javax.swing.JMenuItem jMenuItem3;
	private javax.swing.JMenu jMenu1;
	private javax.swing.JMenu jMenu3;
	private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem1;
	private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem2;
	private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem3;
	private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem4;
	private javax.swing.JMenu jMenu4;
	private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem1;
	private javax.swing.JToolBar jToolBar1;
	private javax.swing.JButton open;
	private javax.swing.JButton save;
	private javax.swing.JButton clearallfields;
	private javax.swing.JButton exit;
	private javax.swing.JPanel ButtonsPane;
	private javax.swing.JButton nextbutton;
	private javax.swing.JButton sendbutton;
	private javax.swing.JTabbedPane jTabbedPane1;
	private javax.swing.JPanel MessagesPane;
	private javax.swing.JLabel messagetype;
	private javax.swing.JTextField messagefield;
	private javax.swing.JLabel content;
	private javax.swing.JLabel replywith;
	private javax.swing.JLabel replyby;
	private javax.swing.JLabel replyto;
	private javax.swing.JLabel replyTo;
	private javax.swing.JLabel lang;
	private javax.swing.JLabel ontology;
	private javax.swing.JLabel protocol;
	private javax.swing.JLabel conversation;
	private javax.swing.JTextField replywithfield;
	private javax.swing.JTextField replybyfield;
	private javax.swing.JTextField inreplyto;
	private javax.swing.JTextField replytofield;
	private javax.swing.JTextField language;
	private javax.swing.JTextField ont;
	private javax.swing.JTextField proto;
	private javax.swing.JTextField convers;
	private javax.swing.JScrollPane jScrollPane3;
	private javax.swing.JTextArea contentArea;
	private javax.swing.JLabel sender;
	private javax.swing.JLabel receiver;
	private javax.swing.JTextField senderfield;
	private javax.swing.JTextField receiverfield;
	private javax.swing.JPanel AclSystemPane;
	private javax.swing.JScrollPane jScrollPane5;
	private javax.swing.JTextArea systArea;
	private javax.swing.JLabel system;
	private javax.swing.JScrollPane jScrollPane1;
	private javax.swing.JTextArea aclArea;
	private javax.swing.JLabel acl;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JLabel _status;
	// End of variables declaration//GEN-END:variables
}
