//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.tool.wizard.panels;

import fipaos.tool.wizard.*;
import fipaos.agent.profile.*;
import fipaos.util.*;
import fipaos.mts.iiop.sun.external.SUNIIOPComms;

import java.util.*;
import javax.swing.*;
import javax.swing.event.*;

public class ACCConfiguration extends javax.swing.JPanel implements WizardPanel
{
	private PlatformProfile _platform_profile;
	private AgentProfile _default_profile;
	private ACCProfile _acc_profile;
	private LoaderProfile _loader_profile;
	private AgentDescription _ams,_df;
	private FIPAOSWizard _parent;
	private Map _setupfipaos;
	private Map _startfipaos;
	private List _ap_names = new LinkedList();
	private List _ap_url = new LinkedList();
	private RAPTableModel _tm = new RAPTableModel();
	
	private boolean _modified = false;
	
		/** Creates new form PlatformDetails */
	public ACCConfiguration(FIPAOSWizard parent)
	{
		_parent = parent;
		initComponents ();
	}
	
		/** This method is called from within the constructor to
		 * initialize the form.
		 * WARNING: Do NOT modify this code. The content of this method is
		 * always regenerated by the FormEditor.
		 */
	private void initComponents()//GEN-BEGIN:initComponents
	{
		jLabel1 = new javax.swing.JLabel();
		jScrollPane1 = new javax.swing.JScrollPane();
		jTable1 = new javax.swing.JTable();
		jButton1 = new javax.swing.JButton();
		jButton2 = new javax.swing.JButton();
		jTextArea3 = new javax.swing.JTextArea();
		jLabel4 = new javax.swing.JLabel();
		setLayout(new java.awt.GridBagLayout());
		java.awt.GridBagConstraints gridBagConstraints1;
		
		jLabel1.setText("What platforms should the ACC look for?");
		jLabel1.setForeground(java.awt.Color.black);
		jLabel1.setFont(new java.awt.Font ("Dialog", 0, 14));
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.insets = new java.awt.Insets(0, 0, 8, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
		add(jLabel1, gridBagConstraints1);
		
		
		jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		jScrollPane1.setMaximumSize(new java.awt.Dimension(32767, 100));
		
		jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
  		jTable1.setCellSelectionEnabled(true);
  		jTable1.setModel(_tm);
  		jTable1.setSelectionModel(new DefaultListSelectionModel());
  		jTable1.setPreferredScrollableViewportSize(new java.awt.Dimension(450, 50));
  		jScrollPane1.setViewportView(jTable1);
  		
  		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridheight = 2;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints1.weighty = 1.0;
		add(jScrollPane1, gridBagConstraints1);
		
		
		jButton1.setText("Add");
		jButton1.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				jButton1ActionPerformed(evt);
			}
		}
		);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(0, 5, 0, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
		add(jButton1, gridBagConstraints1);
		
		
		jButton2.setText("Remove");
		jButton2.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				jButton2ActionPerformed(evt);
			}
		}
		);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(0, 5, 0, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
		add(jButton2, gridBagConstraints1);
		
		
		jTextArea3.setWrapStyleWord(true);
		jTextArea3.setLineWrap(true);
		jTextArea3.setEditable(false);
		jTextArea3.setTabSize(4);
		jTextArea3.setFont(new java.awt.Font ("Dialog", 0, 12));
		jTextArea3.setText("Here you can specify remote Agent Platforms (RAPs) that this platform will interact with.  The name of the RAPs and an MTP address (i.e. a URL) through which individual RAPs can be contacted should be specified.  Generally this will be an MTP address of a RAP's ACC.\n\nExample MTP addresses:\ncorbaname::my-ap.somedomain.com:4000#NameService/acc\nhttp://my-ap.somedomain.com:8080/acc");
		jTextArea3.setAutoscrolls(false);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(0, 0, 5, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
		add(jTextArea3, gridBagConstraints1);
		
		
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints1.weightx = 1.0;
		gridBagConstraints1.weighty = 1.0;
		add(jLabel4, gridBagConstraints1);
		
	}//GEN-END:initComponents
		
  private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
		int i = jTable1.getSelectedRow();
		if( i >= 0 && i < _ap_names.size() )
		{
			_ap_names.remove( i );
			_ap_url.remove( i );
			_tm.notifyChange();
		}
  }//GEN-LAST:event_jButton2ActionPerformed
	
  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
		_ap_names.add( new String() );
		_ap_url.add( new String() );
		_tm.notifyChange();
  }//GEN-LAST:event_jButton1ActionPerformed
	
	public void resetModified()
	{
		_modified = false;
	}
	
	public void initialise(ACCProfile p1,AgentProfile p2,LoaderProfile p3,
	PlatformProfile p4, Map setupfipaos, Map startfipaos )
	{
		_acc_profile = p1;
		_default_profile = p2;
		_loader_profile = p3;
		_platform_profile = p4;
		_setupfipaos = setupfipaos;
		_startfipaos = startfipaos;
		
		// Pull ACC info out of ACCProfile
		List raps = _acc_profile.getRemoteAgentPlatformProfiles();
		if( raps != null )
		{
			Iterator i = raps.iterator();
			while( i.hasNext() )
			{
				RemoteAgentPlatformProfile rapp = (RemoteAgentPlatformProfile) i.next();
				_ap_names.add( rapp.getHAPName() );
				_ap_url.add( rapp.getAddressesLocation() );
			}
		}
	}
	
	public boolean isOk()
	{
		// Do validation
		
		// Calculate step for GUI
		if( _ap_names.size() > 0 )
		{
			int step = 100 / _ap_names.size();
			ProgressDialog pd = new ProgressDialog( _parent, "", "Validating remote address locations", "Starting...." );

			// Put ACC info into ACCProfile
			List raps = _acc_profile.getRemoteAgentPlatformProfiles();
			List new_raps = new LinkedList();
			for( int i = 0; i < _ap_names.size(); i++ )
			{
				RemoteAgentPlatformProfile rapp = new RemoteAgentPlatformProfileImpl();
				rapp.setHAPName( (String) _ap_names.get( i ) );
				rapp.setAddressesLocation( (String) _ap_url.get( i ) );

				pd.setText( "Checking " + (String) _ap_url.get( i ) );

				// Validate address
				if( !validate( (String) _ap_names.get( i ), (String) _ap_url.get( i ) ) )
				{
					pd.dispose();
					return false;
				}

				new_raps.add( rapp );

				pd.setProgress( i * step );
			}

			// Put new RAPs into ACC profile
			raps.clear();
			raps.addAll( new_raps );
			_modified = true;
		
			// Close progress meter
			pd.dispose();		
		}
		else
		{
			// Clear RAP's details
			if (_acc_profile.getRemoteAgentPlatformProfiles() != null)
			{
				_acc_profile.getRemoteAgentPlatformProfiles().clear();
			}
		}
		
		return true;
	}
	
	public boolean isModified()
	{
		return _modified;
	}
	
	private boolean validate( String ap, String addrs )
	{
		boolean ok = true;
		
		// Check if we're using CORBANAME
		if( addrs.toLowerCase().startsWith( "corbaname" ) )
		{
			try
			{
				ok = ( SUNIIOPComms.corbaNameResolve( new URL( addrs ) ) != null );				
			}
			catch( Throwable t )
			{
				ok = false;
			}
		}
		else
		{
			// Attempt to get the addresses
			String doc = DocumentRetriever.getDoc( addrs );
			ok = ( doc != null );
		}
		
		if( !ok )
		{
			int result = JOptionPane.showConfirmDialog( this,
					"The addresses for " + ap + " are not accessible!",
					"", JOptionPane.OK_CANCEL_OPTION );

			ok = ( result == JOptionPane.OK_OPTION );
		}
		
		return ok;
	}
	
	private class RAPTableModel implements javax.swing.table.TableModel
	{
		private final String[] COLUMN = new String[]
		{ "Remote Platform Name", "MTP Address for Remote Platform" };
		private final Class[] COLUMN_CLASS = new Class[]
		{ String.class, String.class };
		private final boolean[] EDITABLE = new boolean[]
		{ true, true };
		private List _listeners = new LinkedList();
		
		public String getColumnName( int i )
		{
			return COLUMN[ i ];
		}
		
		public Class getColumnClass( int i )
		{
			return COLUMN_CLASS[ i ];
		}
		
		public boolean isCellEditable(int rowIndex, int columnIndex)
		{
			return EDITABLE[ columnIndex ];
		}
		
		public void setValueAt(Object aValue, int row, int column)
		{
			switch( column )
			{
				case 0:
					_ap_names.set( row, aValue );
					break;
					
				case 1:
					_ap_url.set( row, aValue );
					break;
			}
		}
		
		public int getRowCount()
		{
			return _ap_names.size();
		}
		
		public int getColumnCount()
		{
			return COLUMN.length;
		}
		
		public Object getValueAt(int row, int column)
		{
			switch( column )
			{
				case 0:
					return _ap_names.get( row );
					
				case 1:
					return _ap_url.get( row );
			}
			
			return null;
		}
		
		public void removeTableModelListener(javax.swing.event.TableModelListener p1)
		{
			_listeners.remove( p1 );
		}
		
		public void addTableModelListener(javax.swing.event.TableModelListener p1)
		{
			_listeners.add( p1 );
		}
		
		public void notifyChange()
		{
			Iterator i = _listeners.iterator();
			while( i.hasNext() )
			{
				TableModelListener tml = (TableModelListener) i.next();
				tml.tableChanged( new TableModelEvent( this ) );
			}
		}
	}
	
	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JLabel jLabel1;
	private javax.swing.JScrollPane jScrollPane1;
	private javax.swing.JTable jTable1;
	private javax.swing.JButton jButton1;
	private javax.swing.JButton jButton2;
	private javax.swing.JTextArea jTextArea3;
	private javax.swing.JLabel jLabel4;
	// End of variables declaration//GEN-END:variables
		
}
