//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis,
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.tool.wizard.panels;


import fipaos.tool.wizard.*;
import fipaos.agent.profile.*;
import fipaos.util.*;

import java.util.*;
import javax.swing.*;

public class PlatformDetails extends javax.swing.JPanel implements WizardPanel
{
	private PlatformProfile _platform_profile;
	private AgentProfile _default_profile;
	private ACCProfile _acc_profile;
	private LoaderProfile _loader_profile;
	private AgentDescription _ams,_df;
	private PlatformDetails _platform_details;
	private FIPAOSWizard _parent;
	private PlatformDistribution _platform_distribution;
	private Map _setupfipaos;
	private Map _startfipaos;
	
	private boolean _modified = false;
	
	/** Creates new form PlatformDetails */
	public PlatformDetails( FIPAOSWizard parent, PlatformDistribution dist )
	{
		
		_parent = parent;
		_platform_distribution = dist;
		initComponents ();
	}
	
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
	private void initComponents()//GEN-BEGIN:initComponents
	{
		jLabel1 = new javax.swing.JLabel();
		jLabel2 = new javax.swing.JLabel();
		_hap = new javax.swing.JTextField();
		jTextArea1 = new javax.swing.JTextArea();
		jLabel3 = new javax.swing.JLabel();
		_ns_host = new javax.swing.JTextField();
		jTextArea3 = new javax.swing.JTextArea();
		_advanced = new javax.swing.JButton();
		jLabel4 = new javax.swing.JLabel();
		setLayout(new java.awt.GridBagLayout());
		java.awt.GridBagConstraints gridBagConstraints1;
		
		jLabel1.setText("What are the details of the Agent Platform?");
		jLabel1.setForeground(java.awt.Color.black);
		jLabel1.setFont(new java.awt.Font ("Dialog", 1, 12));
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 0;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.insets = new java.awt.Insets(0, 0, 8, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
		add(jLabel1, gridBagConstraints1);
		
		
		jLabel2.setText("Platform name");
		jLabel2.setForeground(java.awt.Color.black);
		jLabel2.setFont(new java.awt.Font ("Dialog", 1, 12));
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		add(jLabel2, gridBagConstraints1);
		
		
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints1.weightx = 1.0;
		add(_hap, gridBagConstraints1);
		
		
		jTextArea1.setWrapStyleWord(true);
		jTextArea1.setLineWrap(true);
		jTextArea1.setEditable(false);
		jTextArea1.setTabSize(4);
		jTextArea1.setFont(new java.awt.Font ("Dialog", 0, 12));
		jTextArea1.setText("This should be the name of the computer that will run the Naming Services for the Agent Platform that this installation is part of.  Please do not use \"localhost\" or other potentially ambiguous host names");
		jTextArea1.setAutoscrolls(false);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 4;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(0, 0, 5, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
		gridBagConstraints1.weightx = 1.0;
		add(jTextArea1, gridBagConstraints1);
		
		
		jLabel3.setText("Host running Naming Services");
		jLabel3.setForeground(java.awt.Color.black);
		jLabel3.setFont(new java.awt.Font ("Dialog", 1, 12));
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 3;
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		add(jLabel3, gridBagConstraints1);
		
		
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 1;
		gridBagConstraints1.gridy = 3;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints1.weightx = 1.0;
		add(_ns_host, gridBagConstraints1);
		
		
		jTextArea3.setWrapStyleWord(true);
		jTextArea3.setLineWrap(true);
		jTextArea3.setEditable(false);
		jTextArea3.setTabSize(4);
		jTextArea3.setFont(new java.awt.Font ("Dialog", 0, 12));
		jTextArea3.setText("This is the name of the Agent Platform that this installation of FIPA-OS will be part of.  It should be globally unique if this platform needs to interact with other platforms - FIPA recommends the use of a fully-qualified hostname for this purpose (e.g. myhost.mydomain.com)");
		jTextArea3.setAutoscrolls(false);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 2;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(0, 0, 5, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
		gridBagConstraints1.weightx = 1.0;
		add(jTextArea3, gridBagConstraints1);
		
		
		_advanced.setText("Advanced...");
		_advanced.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				_advancedActionPerformed(evt);
			}
		}
		);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 1;
		gridBagConstraints1.gridy = 5;
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.SOUTHEAST;
		add(_advanced, gridBagConstraints1);
		
		
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 5;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
		gridBagConstraints1.weightx = 1.0;
		gridBagConstraints1.weighty = 1.0;
		add(jLabel4, gridBagConstraints1);
		
	}//GEN-END:initComponents
    
  private void _advancedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__advancedActionPerformed
	  NamingServicePorts nsp = new NamingServicePorts( (java.awt.Frame) _parent, _acc_profile,
	  _platform_profile, _default_profile, this );
	  _modified |= nsp.isModified();
  }//GEN-LAST:event__advancedActionPerformed
  
  public void resetModified()
  {
	  _modified = false;
  }
  
  public void initialise(ACCProfile p1,AgentProfile p2,LoaderProfile p3,
  PlatformProfile p4, Map setupfipaos, Map startfipaos )
  {
	  _acc_profile = p1;
	  _default_profile = p2;
	  _loader_profile = p3;
	  _platform_profile = p4;
	  _setupfipaos = setupfipaos;
	  _startfipaos = startfipaos;
	  
	  // Get HAP name
	  _hap.setText( _platform_profile.getHAPName() );
	  
	  // Get NS name using the host part of the first internal transport address
	  try
	  {
		  URL url = new URL( ( (InternalAddress) _default_profile.getInternalAddresss().get( 0 ) ).getAddress() );
		  _ns_host.setText( url.getHost() );
	  }
	  catch( Throwable t )
	  {
		  DIAGNOSTICS.println( "Exception", t );
	  }
  }
  
  public boolean isOk()
  {
	  // Do validation
	  
	  // Do simple check on HAP
	  String hap = _hap.getText();
	  if( hap.equals( "" ) )
	  {
		  JOptionPane.showMessageDialog( this, "Please enter a name for the Agent Platform" );
		  return false;
	  }
	  else if( hap.equals( FIPAOSWizard.STANDALONE_AP_NAME ) )
	  {
		  JOptionPane.showMessageDialog( this, "Please enter a different name for the Agent Platform" );
		  return false;
	  }
	  else if( hap.indexOf( " " ) > -1 )
	  {
		  JOptionPane.showMessageDialog( this, "Agent Platform name shouldn't contain spaces" );
		  return false;
	  }
	  
	  // Validate NS host
	  String ns_host = _ns_host.getText();
	  if( ns_host.equalsIgnoreCase( "localhost" ) )
	  {
		  JOptionPane.showMessageDialog( this, "Please change the Naming Service host to something other than \"localhost\"" );
		  return false;
	  }
	  else if( ns_host.equals( "" ) )
	  {
		  JOptionPane.showMessageDialog( this, "Please specify a Naming Service host" );
		  return false;
	  }
	  
	  // Check if NS host is reachable!
	  try
	  {
		  java.net.InetAddress.getByName( ns_host );
	  }
	  catch( Throwable t )
	  {
		  DIAGNOSTICS.println( t );
		  int result = JOptionPane.showConfirmDialog( (java.awt.Component)this,
		  "The Naming Service host specified is not reachable!",
		  "", JOptionPane.OK_CANCEL_OPTION );
		  
		  if( result != JOptionPane.OK_OPTION )
		  {
			  return false;
		  }
	  }
	  
	  
	  // Update profiles with HAP name
	  if( !_platform_profile.getHAPName().equals( hap ) )
	  {
		  _platform_profile.setHAPName( hap );
		  _modified = true;
	  }
	  
	  // Update NS host
	  _platform_distribution.setNSHost( ns_host );
	  
	  TransportDefinition transport_def;
	  
	  // Set individual protocol NS ports
	  for( int i = 0; i < FIPAOSWizard.TRANSPORTS.length; i++ )
	  {
		  transport_def = FIPAOSWizard.TRANSPORTS[i];
		  
		  _platform_distribution.setNSPort( transport_def.getName(), transport_def.getNSPort() );
		  updateScriptVar( _startfipaos, transport_def.getName(), "" + transport_def.getNSPort());
		  DIAGNOSTICS.println("Updating " + transport_def.getName() +  " to " + transport_def.getNSPort(), this, DIAGNOSTICS.LEVEL_2);
	  }
	  
	  return true;
  }
  
  public boolean isModified()
  {
	  return _modified;
  }
  
  public void updateScriptVar( Map script, String var, String value )
  {
	  // Change if necessary
	  String script_value = ( (String) script.get( var ) );
	  if( script_value != null && !script_value.equals( value ) )
	  {
		  script.put( var, value );
		  _modified = true;
	  }
  }
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JTextField _hap;
  private javax.swing.JTextArea jTextArea1;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JTextField _ns_host;
  private javax.swing.JTextArea jTextArea3;
  private javax.swing.JButton _advanced;
  private javax.swing.JLabel jLabel4;
  // End of variables declaration//GEN-END:variables
		
}
