//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis,
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.tool.wizard.panels;

import fipaos.tool.configurator.*;
import fipaos.tool.wizard.*;
import fipaos.agent.profile.*;
import fipaos.util.*;

import java.util.*;
import javax.swing.*;

public class PlatformDistribution extends javax.swing.JPanel implements WizardPanel
{
	private ButtonGroup _bg = new ButtonGroup();
	
	private PlatformProfile _platform_profile;
	private AgentProfile _default_profile;
	private ACCProfile _acc_profile;
	private LoaderProfile _loader_profile;
	private AgentDescription _ams,_df;
	private PlatformDetails _platform_details;
	private ACCConfiguration _acc_conf;
	private FIPAOSWizard _parent;
	private Map _setupfipaos;
	private Map _startfipaos;
	
	private boolean _modified = false;
	
	/** Creates new form PlatformDistribution */
	public PlatformDistribution( FIPAOSWizard parent )
	{
		_parent = parent;
		initComponents ();
	}
	
		/** This method is called from within the constructor to
		 * initialize the form.
		 * WARNING: Do NOT modify this code. The content of this method is
		 * always regenerated by the FormEditor.
		 */
	private void initComponents()//GEN-BEGIN:initComponents
	{
		jLabel1 = new javax.swing.JLabel();
		_standalone = new javax.swing.JRadioButton();
		_dist_platform = new javax.swing.JRadioButton();
		_start_ns = new javax.swing.JCheckBox();
		_start_ams_and_df = new javax.swing.JCheckBox();
		jLabel2 = new javax.swing.JLabel();
		jLabel3 = new javax.swing.JLabel();
		jTextArea1 = new javax.swing.JTextArea();
		jTextArea2 = new javax.swing.JTextArea();
		jTextArea3 = new javax.swing.JTextArea();
		jTextArea4 = new javax.swing.JTextArea();
		_start_acc = new javax.swing.JCheckBox();
		jTextArea5 = new javax.swing.JTextArea();
		jLabel4 = new javax.swing.JLabel();
		setLayout(new java.awt.GridBagLayout());
		java.awt.GridBagConstraints gridBagConstraints1;
		
		jLabel1.setText("How should this installation of FIPA-OS be configured?");
		jLabel1.setForeground(java.awt.Color.black);
		jLabel1.setFont(new java.awt.Font ("Dialog", 0, 14));
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 0;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.insets = new java.awt.Insets(0, 0, 8, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		add(jLabel1, gridBagConstraints1);
		
		
		_standalone.setToolTipText("");
		_standalone.setLabel("Standalone platform");
		_standalone.setText("As a stand-alone platform");
		_bg.add( _standalone );
		_standalone.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				jRadioButton1ActionPerformed(evt);
			}
		}
		);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 1;
		gridBagConstraints1.gridy = 1;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		add(_standalone, gridBagConstraints1);
		
		
		_dist_platform.setToolTipText("");
		_dist_platform.setLabel("As part of a distributed platform");
		_dist_platform.setText("As part of a distributed platform / to interoperate with other platforms");
		_bg.add( _dist_platform );
		_dist_platform.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				_dist_platformActionPerformed(evt);
			}
		}
		);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 1;
		gridBagConstraints1.gridy = 3;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		add(_dist_platform, gridBagConstraints1);
		
		
		_start_ns.setToolTipText("");
		_start_ns.setLabel("Start platform NamingServices here");
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 2;
		gridBagConstraints1.gridy = 5;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		add(_start_ns, gridBagConstraints1);
		
		
		_start_ams_and_df.setToolTipText("");
		_start_ams_and_df.setLabel("Start platform agents (AMS & DF) here");
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 2;
		gridBagConstraints1.gridy = 7;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		add(_start_ams_and_df, gridBagConstraints1);
		
		
		jLabel2.setText("      ");
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 1;
		add(jLabel2, gridBagConstraints1);
		
		
		jLabel3.setText("      ");
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 1;
		gridBagConstraints1.gridy = 5;
		add(jLabel3, gridBagConstraints1);
		
		
		jTextArea1.setWrapStyleWord(true);
		jTextArea1.setLineWrap(true);
		jTextArea1.setEditable(false);
		jTextArea1.setTabSize(4);
		jTextArea1.setFont(new java.awt.Font ("Dialog", 0, 12));
		jTextArea1.setText("Select this option if you plan to use FIPA-OS in isolation on this computer.  This is the simplest option, since the majority of configuration will be done automatically");
		jTextArea1.setAutoscrolls(false);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 1;
		gridBagConstraints1.gridy = 2;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(0, 0, 5, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
		gridBagConstraints1.weightx = 1.0;
		gridBagConstraints1.weighty = 1.0;
		add(jTextArea1, gridBagConstraints1);
		
		
		jTextArea2.setWrapStyleWord(true);
		jTextArea2.setLineWrap(true);
		jTextArea2.setEditable(false);
		jTextArea2.setTabSize(4);
		jTextArea2.setFont(new java.awt.Font ("Dialog", 0, 12));
		jTextArea2.setText("Select this option if you wish to use this installation of FIPA-OS as part of an Agent Platform which spans several computers, and/or interacts with other FIPA platforms.  In this case one of the computers that are part of the AgentPlatform must run the Naming Services for the platform, and one must run the AMS and DF agents");
		jTextArea2.setAutoscrolls(false);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 1;
		gridBagConstraints1.gridy = 4;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(0, 0, 5, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
		gridBagConstraints1.weightx = 1.0;
		gridBagConstraints1.weighty = 1.0;
		add(jTextArea2, gridBagConstraints1);
		
		
		jTextArea3.setWrapStyleWord(true);
		jTextArea3.setLineWrap(true);
		jTextArea3.setEditable(false);
		jTextArea3.setTabSize(4);
		jTextArea3.setFont(new java.awt.Font ("Dialog", 0, 12));
		jTextArea3.setText("Select this to start the Agent Platform Naming Services on this computer");
		jTextArea3.setAutoscrolls(false);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 2;
		gridBagConstraints1.gridy = 6;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(0, 0, 5, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
		gridBagConstraints1.weightx = 1.0;
		gridBagConstraints1.weighty = 1.0;
		add(jTextArea3, gridBagConstraints1);
		
		
		jTextArea4.setWrapStyleWord(true);
		jTextArea4.setLineWrap(true);
		jTextArea4.setEditable(false);
		jTextArea4.setTabSize(4);
		jTextArea4.setFont(new java.awt.Font ("Dialog", 0, 12));
		jTextArea4.setText("Select this to start the AMS and DF for the Agent Platform here");
		jTextArea4.setAutoscrolls(false);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 2;
		gridBagConstraints1.gridy = 8;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(0, 0, 5, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
		gridBagConstraints1.weightx = 1.0;
		gridBagConstraints1.weighty = 1.0;
		add(jTextArea4, gridBagConstraints1);
		
		
		_start_acc.setToolTipText("");
		_start_acc.setLabel("Start platform agents (AMS & DF) here");
		_start_acc.setText("Start platform ACC here");
		_start_acc.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				jCheckBox1ActionPerformed(evt);
			}
		}
		);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 2;
		gridBagConstraints1.gridy = 9;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		add(_start_acc, gridBagConstraints1);
		
		
		jTextArea5.setWrapStyleWord(true);
		jTextArea5.setLineWrap(true);
		jTextArea5.setEditable(false);
		jTextArea5.setTabSize(4);
		jTextArea5.setFont(new java.awt.Font ("Dialog", 0, 12));
		jTextArea5.setText("Select this to start the ACC for the Agent Platform here (the ACC is only needed if your platform will interact with other Agent Platforms)");
		jTextArea5.setAutoscrolls(false);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 2;
		gridBagConstraints1.gridy = 10;
		gridBagConstraints1.gridwidth = 0;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(0, 0, 5, 0);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
		gridBagConstraints1.weightx = 1.0;
		gridBagConstraints1.weighty = 1.0;
		add(jTextArea5, gridBagConstraints1);
		
		
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 10;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.VERTICAL;
		gridBagConstraints1.weighty = 1.0;
		add(jLabel4, gridBagConstraints1);
		
	}//GEN-END:initComponents
	
  private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
	  if( _start_acc.isSelected() && !_standalone.isSelected() )
	  {
		  if( _acc_conf == null )
		  {
			  _acc_conf = new ACCConfiguration( _parent );
			  _parent.insertPanel( _platform_details, _acc_conf );
		  }
	  }
	  else
	  {
		  if( _acc_conf != null )
		  {
			  _parent.removePanel( _acc_conf );
			  _acc_conf = null;
		  }
	  }
	  
  }//GEN-LAST:event_jCheckBox1ActionPerformed
  
  private void _dist_platformActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__dist_platformActionPerformed
	  setupComponents( false );
	  jCheckBox1ActionPerformed( null );
  }//GEN-LAST:event__dist_platformActionPerformed
  
  private void jRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
	  setupComponents( true );
	  jCheckBox1ActionPerformed( null );
  }//GEN-LAST:event_jRadioButton1ActionPerformed
  
  private void setupComponents( boolean standalone )
  {
	  _start_ams_and_df.setEnabled( !standalone );
	  _start_ns.setEnabled( !standalone );
	  _start_acc.setEnabled( !standalone );
	  
	  if( standalone )
	  {
		  // Remove PlatformDetails pane - we don't need it!
		  if( _platform_details != null )
		  {
			  _parent.removePanel( _platform_details );
			  _platform_details = null;
		  }
	  }
	  else
	  {
		  // Create PlatformDetails planel if necessary
		  if( _platform_details == null )
		  {
			  _platform_details = new PlatformDetails( _parent, this );
			  _parent.insertPanel( this, _platform_details );
		  }
	  }
  }
  
  private void setupComponents( boolean standalone, boolean ns, boolean agents, boolean acc )
  {
	  // Select & enable/disable as appropriate
	  _standalone.setSelected( standalone );
	  _dist_platform.setSelected( !standalone );
	  _start_ams_and_df.setSelected( agents );
	  _start_ns.setSelected( ns );
	  _start_acc.setSelected( acc );
	  setupComponents( standalone );
	  
	  if( acc && !standalone )
	  {
		  if( _acc_conf == null )
		  {
			  _acc_conf = new ACCConfiguration( _parent );
			  _parent.insertPanel( _platform_details, _acc_conf );
		  }
	  }
	  else
	  {
		  if( _acc_conf != null )
		  {
			  _parent.removePanel( _acc_conf );
			  _acc_conf = null;
		  }
	  }
  }
  
  public void resetModified()
  {
	  _modified = false;
  }
  
  public void initialise(ACCProfile p1,AgentProfile p2,LoaderProfile p3,
  PlatformProfile p4, Map setupfipaos, Map startfipaos )
  {
	  _acc_profile = p1;
	  _default_profile = p2;
	  _loader_profile = p3;
	  _platform_profile = p4;
	  _setupfipaos = setupfipaos;
	  _startfipaos = startfipaos;
	  
	  // Locate AMS & DF profiles, and determine if they are both starting here
	  List l = _loader_profile.getAgentDescriptions();
	  Iterator i = l.iterator();
	  while( i.hasNext() )
	  {
		  AgentDescription ad = (AgentDescription) i.next();
		  if( ad.getAgentName().equalsIgnoreCase( "ams" ) )
		  {
			  _ams = ad;
		  }
		  else if( ad.getAgentName().equalsIgnoreCase( "df" ) )
		  {
			  _df = ad;
		  }
	  }
	  
	  // Check we picked up the AMS & DF ok - if not we need to create the appropriate
	  // entries
	  if( _ams == null )
	  {
		  _ams = new AgentDescriptionImpl();
		  _ams.setAgentName( "ams" );
		  _ams.setClassName( "fipaos.platform.AgentManagementSystem" );
		  _ams.setOwner( "fipaos" );
		  _ams.setStart( false );
		  
		  _loader_profile.addAgentDescription( _ams );
		  
		  _modified = true;
	  }
	  
	  if( _df == null )
	  {
		  _df = new AgentDescriptionImpl();
		  _df.setAgentName( "df" );
		  _df.setClassName( "fipaos.platform.DirectoryFacilitator" );
		  _df.setOwner( "fipaos" );
		  _df.setStart( false );
		  
		  _loader_profile.addAgentDescription( _df );
		  
		  _modified = true;
	  }
	  
	  // Initialise GUI
	  boolean standalone = _platform_profile.getHAPName().equals( FIPAOSWizard.STANDALONE_AP_NAME );
	  boolean start_agents = _ams.getStart() && _df.getStart();
	  boolean start_ns = false;
	  
	  // if any transport definition is set to enabled then initially enable the NS tick box
	  
	  TransportDefinition transport_def;
	  
	  for( int j = 0; j < FIPAOSWizard.TRANSPORTS.length; j++ )
	  {
		  
		  transport_def = FIPAOSWizard.TRANSPORTS[j];
		  
		  if (transport_def.getScriptNSEnableVar() != null)
		  {
			  start_ns = true;
		  }
		  
	  } // end for
	  
	  boolean start_acc = !( (String) _startfipaos.get( ScriptVars.STARTFIPAOS_STARTACC ) ).equals( "" );
	  
	  setupComponents( standalone, start_ns, start_agents, start_acc );
  }
  
  public boolean isOk()
  {
	  // Do validation
	  
	  // Setup everything if standalone is selected
	  if( _standalone.isSelected() )
	  {
		  
		  DIAGNOSTICS.println("STANDALONE", this, DIAGNOSTICS.LEVEL_2);
		  
		  // Set platform name to "localap"
		  if( _platform_profile.getHAPName() == null ||
		  !_platform_profile.getHAPName().equals( FIPAOSWizard.STANDALONE_AP_NAME ) )
		  {
			  _platform_profile.setHAPName( FIPAOSWizard.STANDALONE_AP_NAME );
			  _modified = true;
		  }
		  
		  TransportDefinition transport_def;
		  
		  // Start all internal transport NS's
		  for( int i = 0; i < FIPAOSWizard.TRANSPORTS.length; i++ )
		  {
			  String change_to = null;
			  
			  transport_def = FIPAOSWizard.TRANSPORTS[i];
			  
			  DIAGNOSTICS.println("Checking int transport [" + i + "]= " + transport_def.getName(), this, DIAGNOSTICS.LEVEL_2);
			  
			  // for each tranport that needs an external NS program to start
			  if (transport_def.getScriptNSEnableVar() != null)
			  {
				  
				  // Standalone mode so only start internal transport NS's
				  if( transport_def.getExternal() == true )
				  {
					  change_to = "";
				  }
				  else
				  {
					  change_to = "yes";
				  }
				  
				  updateScriptVar( _startfipaos, transport_def.getScriptNSEnableVar(), change_to );
				  
				  // Update port number to default
				  change_to = "" + transport_def.getNSPort();
				  updateScriptVar( _startfipaos, transport_def.getScriptNSPortVar(), change_to );				  
				  
			  } // end if transport needs script variable to start external NS program
			  
			  // Update profiles with updated host/port number
			  setNSPort( transport_def.getName(), transport_def.getNSPort());
			  DIAGNOSTICS.println("Setting port for " + transport_def.getName() + " to " + transport_def.getNSPort(), this, DIAGNOSTICS.LEVEL_2);
		  }
		  
		  // Update all NS host references to localhost
		  setNSHost( "localhost" );
		  
		  // Disable ACC
		  updateScriptVar( _startfipaos, ScriptVars.STARTFIPAOS_STARTACC, "" );
	  }
	  else
	  {
		  // Setup everything we can for distributed platform startup
		  DIAGNOSTICS.println("DISTRIBUTED", this, DIAGNOSTICS.LEVEL_2);
		  
		  // Start all transport NS's for transports that use an external NS program
		  
		  
		  String start_ns;
		  
		  if ( _start_ns.isSelected() == true )
		  {
			  start_ns =  "yes";
		  }
		  else
		  {
			  start_ns = "";
		  }		  
		  
		  TransportDefinition transport_def;
		  
		  for( int i = 0; i < FIPAOSWizard.TRANSPORTS.length; i++ )
		  {
			  
			  transport_def = FIPAOSWizard.TRANSPORTS[i];
			  DIAGNOSTICS.println("Checking ext transport [" + i + "]= " + transport_def.getName(), this, DIAGNOSTICS.LEVEL_2);
			  
			  // if this transport uses external NS program
			  if (transport_def.getScriptNSEnableVar() != null)
			  {	  
				  DIAGNOSTICS.println("Value of " + transport_def.getScriptNSEnableVar() + " = " + start_ns, this, DIAGNOSTICS.LEVEL_2);
				  updateScriptVar( _startfipaos, transport_def.getScriptNSEnableVar(), start_ns );
				  
				  String change_to = "" + transport_def.getNSPort();
				  updateScriptVar( _startfipaos, transport_def.getScriptNSPortVar(), change_to );				  
			  }
			  
			  // Update profiles with updated host/port number
			  setNSPort( transport_def.getName(), transport_def.getNSPort());
			  DIAGNOSTICS.println("Setting port for " + transport_def.getName() + " to " + transport_def.getNSPort(), this, DIAGNOSTICS.LEVEL_2);
			  
		  } // end for
		  
		  // Start ACC if indicated
		  String start_acc;
		  
		  if ( _start_acc.isSelected() )
		  {
			start_acc = "yes";
		  }
		  else
		  {
			  start_acc = "";
		  }
		  
		  updateScriptVar( _startfipaos, ScriptVars.STARTFIPAOS_STARTACC, start_acc );
		  
	  } // end if standalone
	  
	  // AMS & DF should start under these conditions
	  boolean start_agents = _standalone.isSelected() ||
	  _start_ams_and_df.isSelected();
	  if( _df.getStart() != start_agents )
	  {
		  _df.setStart( start_agents );
		  _modified = true;
	  }
	  
	  if( _ams.getStart() != start_agents )
	  {
		  _ams.setStart( start_agents );
		  _modified = true;
	  }
	  
	  return true;
  }
  
  public void updateScriptVar( Map script, String var, String value )
  {
	  DIAGNOSTICS.println("Updating script var " + var + " = " + value, this, DIAGNOSTICS.LEVEL_2);
	  
	  // Change if necessary
	  String script_value = ( (String) script.get( var ) );
	  if( script_value != null && !script_value.equals( value ) )
	  {
		  script.put( var, value );
		  _modified = true;
	  }
  }
  
  public boolean isModified()
  {
	  return _modified;
  }
  
/**
 * Set the NS host in all appropriate places
 */
  public void setNSHost( String host )
  {

	  //--------------------------------------------------------
	  List addresses = _acc_profile.getInternalAddresss();
	  
	  if (addresses == null)
	  {
		  addresses = new LinkedList();
	  }
	  	  
	  setNSHost( host, addresses );
	  //--------------------------------------------------------
	  addresses = _acc_profile.getExternalAddresss();
	  
	  if (addresses == null)
	  {
		  addresses = new LinkedList();
	  }	  
	  
	  setNSHost( host, addresses );
	  //--------------------------------------------------------
	  addresses = _default_profile.getInternalAddresss();
	  
	  if (addresses == null)
	  {
		  addresses = new LinkedList();
	  }	
	  
	  setNSHost( host, addresses );
	  //--------------------------------------------------------	  
	  
	  // Update platform profile
	  URL url = new URL( _platform_profile.getAMSAddress() );
	  
	  // Check if we actually need to change it
	  if( !url.getHost().equalsIgnoreCase( host ) )
	  {
		  url.setHost( host );
		  _platform_profile.setAMSAddress( url.toString() );
		  _modified = true;
	  }
  }
  
		/**
		 * Set the NS port in all appropriate places
		 */
  public void setNSPort( String protocol, int port )
  {
	  //--------------------------------------------------------	
	  List addresses = _acc_profile.getInternalAddresss();
	  
	  if (addresses == null)
	  {
		  addresses = new LinkedList();
	  }	
	  
	  setNSPort( protocol, port, addresses );
	  //--------------------------------------------------------	  
	  
	  addresses = _acc_profile.getExternalAddresss();
	  
	  if (addresses == null)
	  {
		  addresses = new LinkedList();
	  }	
	  
	  setNSPort( protocol, port, addresses );
	  //--------------------------------------------------------		  
	  addresses = _default_profile.getInternalAddresss();
	  
	  if (addresses == null)
	  {
		  addresses = new LinkedList();
	  }	
	  
	  setNSPort( protocol, port, addresses );
	  //--------------------------------------------------------		  
	  
	  // Update platform profile
	  URL url = new URL( _platform_profile.getAMSAddress() );
	  
	  // Check if we actually need to change it
	  if( url.getProtocol().equalsIgnoreCase( protocol ) && url.getPort() != port )
	  {
		  url.setPort( port );
		  _platform_profile.setAMSAddress( url.toString() );
		  _modified = true;
	  }
  }
  
		/**
		 * Set the NS addresses of the given URL's
		 */
  private void setNSHost( String host, List addrs )
  {
	  
	  if (addrs == null)
	  {
		  DIAGNOSTICS.println("!!! NS address list is null", this, DIAGNOSTICS.LEVEL_2);
		  return;
	  }
	  
	  // Iterate through URL's and set host, if appropriate
	  Iterator i = addrs.iterator();
	  while( i.hasNext() )
	  {
		  Object next = i.next();
		  String str_url = null;
		  
		  if( next instanceof InternalAddress )
		  {
			  str_url = ( (InternalAddress) next ).getAddress();
		  }
		  else if( next instanceof ExternalAddress )
		  {
			  str_url = ( (ExternalAddress) next ).getAddress();
		  }
		  
		  URL url = null;
		  
		  try
		  {
			  // Get next URL
			  url = new URL( str_url );
		  }
		  catch( Throwable t )
		  {
		  }
		  
		  // Set URL (if one was found)
		  if( url != null )
		  {
			  DIAGNOSTICS.println( "Dealing with " + url );
			  
			  // Check if we actually need to change it
			  if( !url.getHost().equalsIgnoreCase( host ) )
			  {
				  url.setHost( host );
				  
				  if( next instanceof InternalAddress )
				  {
					  ( (InternalAddress) next ).setAddress( url.toString() );
				  }
				  else if( next instanceof ExternalAddress )
				  {
					  ( (ExternalAddress) next ).setAddress( url.toString() );
				  }
				  
				  _modified = true;
			  }
		  }
	  }
  }
  
  
		/**
		 * Set the NS addresses of the given URL's
		 */
  private void setNSPort( String protocol, int port, List addrs )
  {
	  // Iterate through URL's and set host, if appropriate
	  Iterator i = addrs.iterator();
	  while( i.hasNext() )
	  {
		  Object next = i.next();
		  String str_url = null;
		  
		  if( next instanceof InternalAddress )
		  {
			  str_url = ( (InternalAddress) next ).getAddress();
		  }
		  else if( next instanceof ExternalAddress )
		  {
			  str_url = ( (ExternalAddress) next ).getAddress();
		  }
		  
		  URL url = null;
		  
		  try
		  {
			  // Get next URL
			  url = new URL( str_url );
		  }
		  catch( Throwable t )
		  {
		  }
		  
		  // Set URL (if one was found)
		  if( url != null )
		  {
			  // Check if we actually need to change it
			  if( url.getProtocol().equalsIgnoreCase( protocol ) &&
			  ( url.getPort() != port ) )
			  {
				  url.setPort( port );
				  
				  if( next instanceof InternalAddress )
				  {
					  ( (InternalAddress) next ).setAddress( url.toString() );
				  }
				  else if( next instanceof ExternalAddress )
				  {
					  ( (ExternalAddress) next ).setAddress( url.toString() );
				  }
				  
				  _modified = true;
			  }
		  }
	  }
  }
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel jLabel1;
  private javax.swing.JRadioButton _standalone;
  private javax.swing.JRadioButton _dist_platform;
  private javax.swing.JCheckBox _start_ns;
  private javax.swing.JCheckBox _start_ams_and_df;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JTextArea jTextArea1;
  private javax.swing.JTextArea jTextArea2;
  private javax.swing.JTextArea jTextArea3;
  private javax.swing.JTextArea jTextArea4;
  private javax.swing.JCheckBox _start_acc;
  private javax.swing.JTextArea jTextArea5;
  private javax.swing.JLabel jLabel4;
  // End of variables declaration//GEN-END:variables
  
}
