//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.tool.wizard.panels;

import java.awt.*;
import javax.swing.*;

public class ProgressDialog extends javax.swing.JDialog
{
	
	private String _dialog_title;
	private String _title;
	private String _text = "";
	
		/** Creates new form ProgressDialog */
	public ProgressDialog(JFrame parent, String diag_title, String title, String operation)
	{
		super ( parent, false);
		
		_dialog_title = diag_title;
		_title = title;
		_text = operation;
		
		initComponents ();
		pack ();
		
		// Check size
		if( getWidth() < 300 )
		{
			setSize( 300, getHeight() );
		}
		
		// Centeralise the window
		Toolkit tk = Toolkit.getDefaultToolkit();
		int x = ( tk.getScreenSize().width - getWidth() ) / 2;
		int y = ( tk.getScreenSize().height - getHeight() ) / 2;
		setLocation( x, y );
		
		setVisible( true );
	}
	
	public void setProgress( int value )
	{
		_progress_bar.setValue( value );
	}
	
	public void setText( String text )
	{
		_text = text;
		_text_label.setText( text );
	}
	
		/** This method is called from within the constructor to
		 * initialize the form.
		 * WARNING: Do NOT modify this code. The content of this method is
		 * always regenerated by the FormEditor.
		 */
	private void initComponents()//GEN-BEGIN:initComponents
	{
		_progress_bar = new javax.swing.JProgressBar();
		_text_label = new javax.swing.JLabel();
		jLabel3 = new javax.swing.JLabel();
		getContentPane().setLayout(new java.awt.GridBagLayout());
		java.awt.GridBagConstraints gridBagConstraints1;
		setTitle(_dialog_title);
		addWindowListener(new java.awt.event.WindowAdapter()
		{
			public void windowClosing(java.awt.event.WindowEvent evt)
			{
				closeDialog(evt);
			}
		}
		);
		
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 1;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(3, 3, 3, 3);
		gridBagConstraints1.weightx = 1.0;
		getContentPane().add(_progress_bar, gridBagConstraints1);
		
		
		_text_label.setText(_text);
		_text_label.setForeground(java.awt.Color.black);
		_text_label.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 2;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(3, 3, 3, 3);
		gridBagConstraints1.weightx = 1.0;
		getContentPane().add(_text_label, gridBagConstraints1);
		
		
		jLabel3.setText(_title);
		jLabel3.setForeground(java.awt.Color.black);
		jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		jLabel3.setFont(new java.awt.Font ("Dialog", 0, 14));
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 0;
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(3, 3, 3, 3);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		getContentPane().add(jLabel3, gridBagConstraints1);
		
	}//GEN-END:initComponents
		
		/** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
			setVisible (false);
			dispose ();
    }//GEN-LAST:event_closeDialog
		
		/**
		 * @param args the command line arguments
		 */
		public static void main (String args[])
		{
		}
		
		
		// Variables declaration - do not modify//GEN-BEGIN:variables
		private javax.swing.JProgressBar _progress_bar;
		private javax.swing.JLabel _text_label;
		private javax.swing.JLabel jLabel3;
		// End of variables declaration//GEN-END:variables
		
}