//******************************************************************************
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files
//     ("the Programs") are Copyright (c) 1999 - 2000 Nortel Networks
//     Corporation, 8200 Dixie Road, Suite 100, Brampton, Ontario, Canada
//     L6R 5P6.  All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out
//     in the Nortel Networks FIPA-OS Public License, a copy of which can be
//     found in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version
//     can also be found at http://fipa-os.sourceforge.net/. By  downloading
//     the files containing the Programs you accept the terms and conditions of
//     the Public License. You do not have to accept these terms and conditions,
//     but unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s):
//    Emorphia agree to provide Modifications to Nortel Networks' FIPA-OS
//    Covered Code under Nortel Networks' FIPA-OS Public License. All Emorphia's
//    Modifications remain Copyright (c) 2001 Emorphia Limited. All Rights
//    Reserved.
//
//******************************************************************************

package fipaos.util.objecteditor.primitive;

import fipaos.util.*;
import fipaos.util.objecteditor.*;

import javax.swing.*;

public class BooleanEditorPanel extends javax.swing.JPanel  implements ObjectEditorComponent
{
/** Current value of the boolean property
 */
	boolean _value = false;
/** Indicates if the property is actually null
 */
	boolean _null = false;
	
	public BooleanEditorPanel( Object value )
	{
		if( value instanceof Boolean )
		{
			_value = ((Boolean) value).booleanValue();
		}
		else
		{
			_null = true;
		}
		
		initComponents ();
		
		// Setup button group
		ButtonGroup bg = new ButtonGroup();
		bg.add( _true );
		bg.add( _false );
	}
	
/** Gets the Boolean value this editor has generated through user interactions
 * @return
 */
	public java.lang.Object getValue()
	{
		if( _null )
		{
			return null;
		}
		else
		{
			return new Boolean( _value );
		}
	}
	
		/** This method is called from within the constructor to
		 * initialize the form.
		 * WARNING: Do NOT modify this code. The content of this method is
		 * always regenerated by the FormEditor.
		 */
	private void initComponents()//GEN-BEGIN:initComponents
	{
		_true = new javax.swing.JRadioButton();
		_false = new javax.swing.JRadioButton();
		setLayout(new java.awt.GridBagLayout());
		java.awt.GridBagConstraints gridBagConstraints1;
		
		_true.setSelected(_value);
		_true.setText("true");
		_true.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				_trueActionPerformed(evt);
			}
		}
		);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.insets = new java.awt.Insets(3, 3, 3, 3);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		add(_true, gridBagConstraints1);
		
		
		_false.setSelected(!_value);
		_false.setText("false");
		_false.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				_falseActionPerformed(evt);
			}
		}
		);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.insets = new java.awt.Insets(3, 3, 3, 3);
		gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints1.weightx = 1.0;
		add(_false, gridBagConstraints1);
		
	}//GEN-END:initComponents
	
  private void _falseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__falseActionPerformed
		_value = false;
		_null = false;
  }//GEN-LAST:event__falseActionPerformed
	
  private void _trueActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__trueActionPerformed
		_value = true;
		_null = false;
  }//GEN-LAST:event__trueActionPerformed
	
	
	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JRadioButton _true;
	private javax.swing.JRadioButton _false;
	// End of variables declaration//GEN-END:variables
	
}
