//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.util.objecteditor.primitive;

import fipaos.util.*;
import fipaos.util.objecteditor.*;

/**
 * Super-class for collection-specific sub-classes to extend with parsing and modification
 * code
 */
public abstract class CollectionEditorPanel extends javax.swing.JPanel implements ObjectEditorComponent
{
	/**
	 * Value currently within the UI
	 */
	protected String _value;
	
		/** Creates new form StringEditorPanel */
	public CollectionEditorPanel( Object value )
	{
		if( value == null )
		{
			_value = "null";
		}
		else
		{
			_value = value.toString();
		}
		
		initComponents ();
	}
	
	public abstract java.lang.Object getValue();
	
	/**
	 * Sub classes should implement this method to display some dialog
	 * to allow modification of the collection this edits
	 */
	public abstract void modifyValue();
	
	
		/** This method is called from within the constructor to
		 * initialize the form.
		 * WARNING: Do NOT modify this code. The content of this method is
		 * always regenerated by the FormEditor.
		 */
	private void initComponents()//GEN-BEGIN:initComponents
	{
		jTextField1 = new javax.swing.JTextField();
		jButton1 = new javax.swing.JButton();
		setLayout(new java.awt.GridBagLayout());
		java.awt.GridBagConstraints gridBagConstraints1;
		
		jTextField1.setEditable(false);
		jTextField1.setText(_value);
		jTextField1.addInputMethodListener(new java.awt.event.InputMethodListener()
		{
			public void inputMethodTextChanged(java.awt.event.InputMethodEvent evt)
			{
				textChanged(evt);
			}
			public void caretPositionChanged(java.awt.event.InputMethodEvent evt)
			{
				
			}
		}
		);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.insets = new java.awt.Insets(3, 3, 3, 3);
		gridBagConstraints1.weightx = 1.0;
		add(jTextField1, gridBagConstraints1);
		
		
		jButton1.setText("...");
		jButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));
		jButton1.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				jButton1ActionPerformed(evt);
			}
		}
		);
		
		gridBagConstraints1 = new java.awt.GridBagConstraints();
		gridBagConstraints1.insets = new java.awt.Insets(3, 3, 3, 3);
		add(jButton1, gridBagConstraints1);
		
	}//GEN-END:initComponents
	
  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
		Thread t = new Thread( new Runnable()
		{
			public void run()
			{
				modifyValue();
				if( getValue() == null )
				{
					_value = null;
				}
				else
				{
					_value = getValue().toString();
				}
				jTextField1.setText( _value );
			}
		} );
		t.start();
  }//GEN-LAST:event_jButton1ActionPerformed
	
  private void textChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_textChanged
		_value = jTextField1.getText();
  }//GEN-LAST:event_textChanged
	
	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JTextField jTextField1;
	private javax.swing.JButton jButton1;
	// End of variables declaration//GEN-END:variables
	
}
