//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.util.objecteditor.primitive;

import fipaos.util.*;
import fipaos.util.objecteditor.*;

import java.util.*;
import javax.swing.*;

/**
 * Panel to allow the selection of values for a property which can only take
 * a constrained set of values
 */
public class ConstrainedChoicePanel extends javax.swing.JPanel implements ObjectEditorComponent
{
	/**
	 * Currently selected value
	 */
	private Object _value = null;
	
	/**
	 * Possible selections
	 */
	private List _values;
	
	/**
	 * Text for possible selections
	 */
	private List _texts;
	
	public ConstrainedChoicePanel(DynamicClass.Property prop)
	{
		// Get possible values
		_values = Arrays.asList( ( (DynamicClass.ConstrainedSelectionHint) prop.getHint() )._selections );
		_texts = Arrays.asList( ( (DynamicClass.ConstrainedSelectionHint) prop.getHint() )._selection_texts );
		
		// Get selected value & index
		_value = prop.getValue();
		
		// Init GUI
		initComponents ();
		
		// Select appropriate entry
		if( _value != null )
		{
			int value = _values.indexOf( _value );
			jComboBox1.setSelectedIndex( value );
		}
	}
	
	public java.lang.Object getValue()
	{
		return _value;
	}
	
		/** This method is called from within the constructor to
		 * initialize the form.
		 * WARNING: Do NOT modify this code. The content of this method is
		 * always regenerated by the FormEditor.
		 */
	private void initComponents()//GEN-BEGIN:initComponents
	{
		jComboBox1 = new JComboBox( new Vector( _texts ) );
		setLayout(new java.awt.BorderLayout());
		
		jComboBox1.setSelectedItem(_value);
		jComboBox1.addItemListener(new java.awt.event.ItemListener()
		{
			public void itemStateChanged(java.awt.event.ItemEvent evt)
			{
				selectionChange(evt);
			}
		}
		);
		
		add(jComboBox1, java.awt.BorderLayout.CENTER);
		
	}//GEN-END:initComponents

  private void selectionChange(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_selectionChange
		_value = jComboBox1.getSelectedItem();
  }//GEN-LAST:event_selectionChange
	
	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JComboBox jComboBox1;
	// End of variables declaration//GEN-END:variables
	
}
