//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.util.objecteditor.primitive;

import javax.swing.*;

/**
 * Extends NumberEditorPanel - essentially provides type-specific
 * validation and creation
 */
public class FloatEditorPanel extends fipaos.util.objecteditor.primitive.NumberEditorPanel
{
	public FloatEditorPanel(Object value)
	{
		super( value );
	}
	
	public java.lang.Object getValue()
	{
		if( _value != null )
		{
			try
			{
				return new Float( _value );
			}
			catch( NumberFormatException t )
			{
				JOptionPane.showMessageDialog( this, "Couldn't parse value \"" + _value + "\" as a Float" );
				return null;
			}
		}
		else
		{
			return null;
		}
	}
}
