//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  The contents of this file are subject to the Emorphia Public License (the 
//  "License"); you may not use this file except in compliance with the License.
//  You may obtain a copy of the License at http://www.emorphia.com/EPL/
//
//  Software distributed under the License is distributed on an "AS IS" basis, 
//  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
//  for the specific language governing rights and limitations under the
//  License.
//
//  The Original Code is FIPA-OS.
//
//  The Initial Developer of the Original Code is Emorphia.
//
//  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
//  licensed under the Emorphia Public License, available at
//  http://www.emorphia.com/EPL/.
//
//  All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.util.objecteditor.primitive;

import fipaos.util.*;
import fipaos.util.objecteditor.*;

/**
 * Super-class for number-primitive specific sub-classes to extend with parsing 
 * code
 */
public abstract class NumberEditorPanel extends javax.swing.JPanel implements ObjectEditorComponent
{
	protected String _value = "";
	
	public NumberEditorPanel(Object value)
	{
		if( value instanceof String )
		{
			_value = (String) value;
		}
		else if( value != null )
		{
			_value = value.toString();
		}
		else
		{
			_value = null;
		}
		
		initComponents ();
	}
	
	public abstract java.lang.Object getValue();
	
		/** This method is called from within the constructor to
		 * initialize the form.
		 * WARNING: Do NOT modify this code. The content of this method is
		 * always regenerated by the FormEditor.
		 */
	private void initComponents()//GEN-BEGIN:initComponents
	{
		jTextField1 = new javax.swing.JTextField();
		setLayout(new java.awt.BorderLayout());
		
		jTextField1.setText(_value);
		jTextField1.addFocusListener(new java.awt.event.FocusAdapter()
		{
			public void focusLost(java.awt.event.FocusEvent evt)
			{
				componentFocusLost(evt);
			}
		}
		);
		jTextField1.addKeyListener(new java.awt.event.KeyAdapter()
		{
			public void keyTyped(java.awt.event.KeyEvent evt)
			{
				textChanged1(evt);
			}
		}
		);
		
		add(jTextField1, java.awt.BorderLayout.CENTER);
		
	}//GEN-END:initComponents

  private void textChanged1(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_textChanged1
		_value = jTextField1.getText();
  }//GEN-LAST:event_textChanged1

  private void componentFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_componentFocusLost
		// Execute validation code
		if( getValue() == null )
		{
			requestFocus();
		}
  }//GEN-LAST:event_componentFocusLost

  private void textChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_textChanged
		_value = jTextField1.getText();
  }//GEN-LAST:event_textChanged
		
	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JTextField jTextField1;
	// End of variables declaration//GEN-END:variables
		
}
