//******************************************************************************
//
//  Open Source Copyright Notice and License: FIPA-OS
//
//  1. The programs and other works made available to you in these files ("the
//     Programs") are Copyright (c) 1999 - 2000 Nortel Networks Corporation, 
//     8200 Dixie Road, Suite 100, Brampton, Ontario, Canada L6R 5P6.  
//     All rights reserved.
//
//  2. Your rights to copy, distribute and modify the Programs are as set out in
//     the Nortel Networks FIPA-OS Public License, a copy of which can be found
//     in file "Nortel_FIPA_OS_Public_Licence.txt" and the latest version can
//     also be found at http://fipa-os.sourceforge.net/. By downloading the
//     files containing the Programs you accept the terms and  conditions of the
//     Public License. You do not have to accept these terms and conditions, but
//     unless you do so you have no rights to use the Programs.
//
//  The Original Code is Nortel Networks' FIPA-OS (Foundation for Intelligent
//  Physical Agents - Open Source).
//
//  The Initial Developer of the Original Code is Nortel Networks Corporation.
//  Portions created by Nortel Networks Corporation or its subsidiaries are
//  Copyright (c) 1999 - 2000 Nortel Networks Corporation. All Rights Reserved.
//
//  Contributor(s):
//  (add contributor names here)
//
//******************************************************************************

package fipaos.util.proxy;

//----------------------------------------------------------------------

import java.net.*;
import java.lang.*;
import java.io.*;
import java.util.*;

public class ProxySocket 
{
	//member variables
	Socket _client;
	String _machine_name;
	
	OutputStream _write_stream;
	InputStream	_read_stream;
	
	//member methods
	public ProxySocket(String host, int port) 
	{
		try 
		{
			_client = new Socket(InetAddress.getByName(host), port);
			
			_machine_name = host;
			_write_stream = _client.getOutputStream();
			_read_stream	= _client.getInputStream();
		}
		catch(Exception e) 
		{
			fipaos.util.DIAGNOSTICS.println("Exception");			 			
 			e.printStackTrace();

 		}
	} // end method MySocket()
		
	private String readSocket() 
	{
		String result = new String();
		int read = -1;
		
		try 
		{
			read = _read_stream.read();
		}
		catch(Exception e) 
		{
			fipaos.util.DIAGNOSTICS.println("Exception");			 			
 			e.printStackTrace();

		}
		
		while(read != -1) 
		{
			result += (char)read;
			
			try 
			{
				read = _read_stream.read();			
			}
			catch(Exception e) 
			{
				fipaos.util.DIAGNOSTICS.println("Exception");			 			
 				e.printStackTrace();

			}
		}
		
		return result;
	}
			
	private void writeSocket(String input) 
	{
	  byte output[] = input.getBytes();

		for (int w = 0; w < input.length(); w++) 
		{
			try 
			{
			 	_write_stream.write(output[w]);
				_write_stream.flush();
			}
			catch(Exception e) 
			{
				fipaos.util.DIAGNOSTICS.println("Exception");			 			
	 			e.printStackTrace();

			}			
		}
	}
	
	public String getProxyScript(String document) 
	{
		writeSocket("GET http://" + _machine_name + "/" + document + " HTTP/1.0\n\n");
		return readSocket();
	}
		

} // end class ProxySocket
