@rem ******************************************************************************
@rem 
@rem  Open Source Copyright Notice and License: FIPA-OS
@rem 
@rem  The contents of this file are subject to the Emorphia Public License (the 
@rem  "License"); you may not use this file except in compliance with the License.
@rem  You may obtain a copy of the License at http://www.emorphia.com/EPL/
@rem 
@rem  Software distributed under the License is distributed on an "AS IS" basis, 
@rem  WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
@rem  for the specific language governing rights and limitations under the
@rem  License.
@rem 
@rem  The Original Code is FIPA-OS.
@rem 
@rem  The Initial Developer of the Original Code is Emorphia.
@rem 
@rem  Portions created by Emorphia are Copyright (C) 2001 Emorphia Limited
@rem  licensed under the Emorphia Public License, available at
@rem  http://www.emorphia.com/EPL/.
@rem
@rem  All Rights Reserved.
@rem 
@rem  Contributor(s):
@rem  (add contributor names here)
@rem 
@rem ******************************************************************************
@cd ..\bat
@call SetupFIPAOS.bat
@echo off

cd %FIPAOS%

REM Create Package dir
IF NOT EXIST %TEMP%\package GOTO SKIPDEL
echo Removing temporary files from last package construction...
del /S /F /Q %TEMP%\package >NUL:
:SKIPDEL

IF NOT EXIST %TEMP%\package MKDIR %TEMP%\package >NUL:

REM Copy dirs into package
echo Copying profiles and certificates...
XCOPY /S /Y /I profiles %TEMP%\package\profiles >NUL:
XCOPY /S /Y /I certificates %TEMP%\package\certificates >NUL:
COPY tools\FORE.mf %TEMP% >NUL:

REM Extract JARs into package dir
CD %TEMP%\package
echo Extracting FIPA-OS JAR...
JAR xf %FIPAOS%\classes\FIPA_OSv%FIPAOS_VER%%DEBUGVER%.jar
echo Copying FIPA-OS classes directory...
XCOPY /S /Y /I %FIPAOS%\classes .  >NUL:
DEL /F /Q *.jar >NUL:
DEL /S /F /Q fipaos\test >NUL:
echo Extracting 3rd party JARs...
FOR %%i IN (%FIPAOS%\imports\*.jar) DO JAR xf "%%i"

REM Move licenses into "license" dir
IF NOT EXIST licenses MKDIR licenses >NUL:
echo Copying FIPA-OS licenses
FOR %%i IN (%FIPAOS%\docs\licenses\*) DO COPY "%%i" licenses >NUL:
echo Copying 3rd party licenses...
FOR %%i IN (*) DO MOVE "%%i" licenses >NUL:

REM Create JAR
echo Creating Executable JAR...
JAR cfm %FIPAOS%\FOREv%FIPAOS_VER%.jar %TEMP%\FORE.mf
FOR /D %%i IN (*) DO IF NOT "%%i" == "META-INF" JAR uf %FIPAOS%\FOREv%FIPAOS_VER%.jar "%%i"

REM Clean up
echo Tidying up...
cd %FIPAOS%\tools
del %TEMP%\FORE.mf >NUL:
del /S /F /Q %TEMP%\package >NUL:
pause
